package com.glxp.api.admin.controller.info;

import com.github.pagehelper.PageInfo;
import com.glxp.api.admin.entity.info.CompanyEntity;
import com.glxp.api.admin.entity.info.ThirdSysApiEntity;
import com.glxp.api.admin.entity.inout.OrderEntity;
import com.glxp.api.admin.entity.inout.WarehouseEntity;
import com.glxp.api.admin.req.info.FilterSysApiRequest;
import com.glxp.api.admin.req.inout.OrderFilterRequest;
import com.glxp.api.admin.res.PageSimpleResponse;
import com.glxp.api.admin.service.info.CompanyService;
import com.glxp.api.admin.service.info.ThirdSysApiService;
import com.glxp.api.common.enums.ResultEnum;
import com.glxp.api.common.res.BaseResponse;
import com.glxp.api.common.util.ResultVOUtils;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;

@RestController
public class ThirdSysApiController {


    @Resource
    private ThirdSysApiService thirdSysApiService;

    @GetMapping("/sys/api/findAll")
    public BaseResponse findAll(FilterSysApiRequest filterSysApiRequest) {
        List<ThirdSysApiEntity> thirdSysApiEntities = thirdSysApiService.findSysApi(filterSysApiRequest);
        PageInfo<ThirdSysApiEntity> pageInfo;
        pageInfo = new PageInfo<>(thirdSysApiEntities);
        PageSimpleResponse<ThirdSysApiEntity> pageSimpleResponse = new PageSimpleResponse<>();
        pageSimpleResponse.setTotal(pageInfo.getTotal());
        pageSimpleResponse.setList(thirdSysApiEntities);
        return ResultVOUtils.success(pageSimpleResponse);
    }

    @PostMapping("/sys/api/modifyApi")
    public BaseResponse modifyApi(@RequestBody ThirdSysApiEntity thirdSysApiEntity) {

        boolean b = thirdSysApiService.modifySysApi(thirdSysApiEntity);
        if (b)
            return ResultVOUtils.success("修改成功");
        else
            return ResultVOUtils.error(500, "修改失败");
    }
}
