package com.glxp.api.admin.controller.inout;

import com.github.pagehelper.PageInfo;
import com.glxp.api.admin.entity.inout.WarehouseEntity;
import com.glxp.api.admin.req.basic.FilterUdiInfoRequest;
import com.glxp.api.admin.req.inout.WarehouseQueryRequest;
import com.glxp.api.admin.res.PageSimpleResponse;
import com.glxp.api.admin.res.basic.UdiRelevanceResponse;
import com.glxp.api.admin.res.basic.UdiTraceResponse;
import com.glxp.api.admin.service.basic.UdiRelevanceService;
import com.glxp.api.admin.service.inout.CodesService;
import com.glxp.api.common.res.BaseResponse;
import com.glxp.api.common.util.ResultVOUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;
import java.util.stream.Collectors;

@RestController
public class UdiTraceController {

    @Resource
    private CodesService warehouseService;
    @Resource
    UdiRelevanceService udiRelevanceService;

    @GetMapping("udiwarehouse/trace/filter")
    public BaseResponse list(WarehouseQueryRequest warehouseQueryRequest) {
        List<WarehouseEntity> warehouseEntityList = warehouseService.findByOrderId(warehouseQueryRequest);
        if (warehouseEntityList != null && warehouseEntityList.size() > 0) {
            WarehouseEntity warehouseEntity = warehouseEntityList.get(0);
            String udi = warehouseEntity.getCode().substring(2, 16);
            FilterUdiInfoRequest filterUdiInfoRequest = new FilterUdiInfoRequest();
            filterUdiInfoRequest.setNameCode(udi);
            List<UdiRelevanceResponse> udiRelevanceResponses = udiRelevanceService.filterUdiGp(filterUdiInfoRequest);
            UdiRelevanceResponse udiRelevance = null;
            if (udiRelevanceResponses != null && udiRelevanceResponses.size() > 0) {
                udiRelevance = udiRelevanceResponses.get(0);
            }

            UdiRelevanceResponse finalUdiRelevance = udiRelevance;
            List<UdiTraceResponse> udiTraceResponseList = warehouseEntityList.stream().map(item ->
            {
                UdiTraceResponse udiTraceResponse = new UdiTraceResponse();
                BeanUtils.copyProperties(item, udiTraceResponse);
                if(finalUdiRelevance!=null){
                    udiTraceResponse.setYlqxzcrbarmc(finalUdiRelevance.getYlqxzcrbarmc());
                    udiTraceResponse.setCpmctymc(finalUdiRelevance.getCpmctymc());
                    udiTraceResponse.setGgxh(finalUdiRelevance.getGgxh());
                }
                return udiTraceResponse;
            }).collect(Collectors.toList());
            PageInfo<UdiTraceResponse> pageInfo;
            pageInfo = new PageInfo<>(udiTraceResponseList);
            PageSimpleResponse<UdiTraceResponse> pageSimpleResponse = new PageSimpleResponse<>();
            pageSimpleResponse.setTotal(pageInfo.getTotal());
            pageSimpleResponse.setList(udiTraceResponseList);
            return ResultVOUtils.success(pageSimpleResponse);
        }else {
            return ResultVOUtils.error(500,"未找到该条码！");
        }
    }
}
