package com.glxp.api.admin.controller.itextpdf;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.glxp.api.admin.entity.basic.BussinessTypeEntity;
import com.glxp.api.admin.entity.info.SystemPDFModuleEntity;
import com.glxp.api.admin.entity.info.SystemPDFTemplateEntity;
import com.glxp.api.admin.entity.info.SystemPDFTemplateRelevanceEntity;
import com.glxp.api.admin.entity.inout.ErpOrderEntity;
import com.glxp.api.admin.entity.inout.FilterErpOrderRequest;
import com.glxp.api.admin.entity.inout.OrderEntity;
import com.glxp.api.admin.req.info.SystemPDFTemplateRequest;
import com.glxp.api.admin.req.itextpdf.InoutOrderDetailPDFCodeRequest;
import com.glxp.api.admin.req.itextpdf.InoutOrderDetailPDFFileRequest;
import com.glxp.api.admin.req.itextpdf.InspectionPDFTemplateRequest;
import com.glxp.api.admin.service.basic.BussinessTypeService;
import com.glxp.api.admin.service.info.SystemPDFModuleService;
import com.glxp.api.admin.service.info.SystemPDFTemplateRelevanceService;
import com.glxp.api.admin.service.info.SystemPDFTemplateService;
import com.glxp.api.admin.service.inout.OrderDetailService;
import com.glxp.api.admin.service.inout.OrderService;
import com.glxp.api.admin.util.ITextPDFUtils;
import com.glxp.api.common.enums.ResultEnum;
import com.glxp.api.common.res.BaseResponse;
import com.glxp.api.common.util.ResultVOUtils;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@RestController
public class PDFDawnloadController {

    @Resource
    private OrderService orderService;
    @Resource
    private BussinessTypeService bussinessTypeService;
    @Resource
    private OrderDetailService orderDetailService;
    @Resource
    private SystemPDFTemplateRelevanceService systemPDFTemplateRelevanceService;
    @Resource
    private SystemPDFTemplateService systemPDFTemplateService;
    @Resource
    private SystemPDFModuleService systemPDFModuleService;

    /**
     * 下载pdf文档
     *
     * @throws Exception
     */
    @GetMapping("/udiwms/pdf/download/test")
    public void downloadTestPDF(HttpServletRequest request, HttpServletResponse response) throws Exception {
//        ITextPDFUtils.exportPDFTest(request, response);
        //-----------------------------------------------------------
        SystemPDFModuleEntity systemPDFModuleEntity = systemPDFModuleService.selectById(1 + "");
        if (systemPDFModuleEntity != null) {
            SystemPDFTemplateEntity systemPDFTemplateEntity =
                    systemPDFTemplateService.selectById(String.valueOf(systemPDFModuleEntity.getTemplateId()));
            if (systemPDFTemplateEntity != null) {
                ITextPDFUtils.exportPDFFromTemplateFileTest(systemPDFTemplateEntity.getPath(), request, response);
            }
        }
        //-----------------------------------------------------------
    }

    /**
     * 代码生成，配置从前端传入
     */
    @PostMapping("/udiwms/pdf/download/inout/order/success")
    public void downloadInoutOrderSuccessPDF(@RequestBody InoutOrderDetailPDFCodeRequest inoutOrderDetailPDFCodeRequest, HttpServletRequest request, HttpServletResponse response) throws Exception {

        OrderEntity orderEntity = orderService.findById(inoutOrderDetailPDFCodeRequest.getOrderId());
        if (orderEntity == null) {
            return;
        }

        inoutOrderDetailPDFCodeRequest.setFromCorp(orderEntity.getFromCorp());
        inoutOrderDetailPDFCodeRequest.setFromType(orderEntity.getFromType());
        BussinessTypeEntity bussinessTypeEntity = bussinessTypeService.findBTByAction(orderEntity.getAction());
        inoutOrderDetailPDFCodeRequest.setActionName(bussinessTypeEntity == null ? " " : bussinessTypeEntity.getName());

        FilterErpOrderRequest filterErpOrderRequest = new FilterErpOrderRequest();
        filterErpOrderRequest.setOrderIdFk(inoutOrderDetailPDFCodeRequest.getOrderId());
        List<ErpOrderEntity> erpOrderEntityList = orderDetailService.filterAllMyErpOrder(filterErpOrderRequest);

        ITextPDFUtils.exportInoutOrderSuccessPDF(inoutOrderDetailPDFCodeRequest, erpOrderEntityList, request, response);
    }


    /**
     * 代码生成模板，模板数据从数据库获取
     */
    @PostMapping("/udiwms/template/pdf/order/detail/code")
    public void orderDetailPDFFromTemplateCode(
            @RequestBody InoutOrderDetailPDFCodeRequest inoutOrderDetailPDFCodeRequest,
            HttpServletRequest request, HttpServletResponse response) throws Exception {

        OrderEntity orderEntity = orderService.findById(inoutOrderDetailPDFCodeRequest.getOrderId());
        if (orderEntity == null) {
            return;
        }

//        Map<String, Object> rMap = inspectionCustomerPDFTemplate(inoutOrderSuccessPDFRequest.getCustomerId());
//        if (Integer.parseInt(String.valueOf(rMap.get("code"))) != 0) {
//            return;
//        }
//        String settingDataJsonString = String.valueOf(rMap.get("data"));

        SystemPDFTemplateEntity systemPDFTemplateEntity = systemPDFTemplateService.selectById("1");
        if (systemPDFTemplateEntity == null) return;
        String settingDataJsonString = systemPDFTemplateEntity.getParam();

        JSONObject settingDataJson = JSONObject.parseObject(settingDataJsonString);
        InoutOrderDetailPDFCodeRequest.SettingData settingData =//JSON转实体类
                JSON.toJavaObject(settingDataJson, InoutOrderDetailPDFCodeRequest.SettingData.class);
        inoutOrderDetailPDFCodeRequest.setSettingData(settingData);
        //-----------------------------------------------
        inoutOrderDetailPDFCodeRequest.setFromCorp(orderEntity.getFromCorp());
        inoutOrderDetailPDFCodeRequest.setFromType(orderEntity.getFromType());
        BussinessTypeEntity bussinessTypeEntity = bussinessTypeService.findBTByAction(orderEntity.getAction());
        inoutOrderDetailPDFCodeRequest.setActionName(bussinessTypeEntity == null ? " " : bussinessTypeEntity.getName());

        FilterErpOrderRequest filterErpOrderRequest = new FilterErpOrderRequest();
        filterErpOrderRequest.setOrderId(inoutOrderDetailPDFCodeRequest.getOrderId());
        List<ErpOrderEntity> erpOrderEntityList = orderDetailService.filterAllMyErpOrder(filterErpOrderRequest);

        ITextPDFUtils.exportInoutOrderSuccessPDF(inoutOrderDetailPDFCodeRequest, erpOrderEntityList, request, response);
    }

    /**
     * 模板导入，模板文件路径从数据库获取
     */
    @PostMapping("/udiwms/pdf/template/order/detail/file")
    public void orderDetailPDFFromTemplateFile(
            @RequestBody InoutOrderDetailPDFFileRequest inoutOrderDetailPDFFileRequest,
            HttpServletRequest request, HttpServletResponse response) throws Exception {

        OrderEntity orderEntity = orderService.findById(inoutOrderDetailPDFFileRequest.getOrderId());
        if (orderEntity == null) {
            return;
        }

        SystemPDFModuleEntity systemPDFModuleEntity = systemPDFModuleService.selectById(1 + "");
        if (systemPDFModuleEntity == null) return;
        SystemPDFTemplateEntity systemPDFTemplateEntity =
                systemPDFTemplateService.selectById(String.valueOf(systemPDFModuleEntity.getTemplateId()));
        if (systemPDFTemplateEntity == null) return;
        inoutOrderDetailPDFFileRequest.setPath(systemPDFTemplateEntity.getPath());
        inoutOrderDetailPDFFileRequest.setRowCount(systemPDFTemplateEntity.getRowCount());
        inoutOrderDetailPDFFileRequest.setQrcodeCount(systemPDFTemplateEntity.getQrcodeCount());
        //-----------------------------------------------
        inoutOrderDetailPDFFileRequest.setFromCorp(orderEntity.getFromCorp());
        inoutOrderDetailPDFFileRequest.setFromType(orderEntity.getFromType());
        inoutOrderDetailPDFFileRequest.setActDate(orderEntity.getActDate());
        BussinessTypeEntity bussinessTypeEntity = bussinessTypeService.findBTByAction(orderEntity.getAction());
        inoutOrderDetailPDFFileRequest.setActionName(bussinessTypeEntity == null ? " " : bussinessTypeEntity.getName());

        FilterErpOrderRequest filterErpOrderRequest = new FilterErpOrderRequest();
        filterErpOrderRequest.setOrderId(inoutOrderDetailPDFFileRequest.getOrderId());
        List<ErpOrderEntity> erpOrderEntityList = orderDetailService.filterAllMyErpOrder(filterErpOrderRequest);

        ITextPDFUtils.exportOrderDetailPDFFromTemplateFile(
                inoutOrderDetailPDFFileRequest, erpOrderEntityList, request, response);
    }

    @PostMapping("/udiwms/pdf/template/preview")
    public BaseResponse previewPDFTemplate(
            @RequestBody InspectionPDFTemplateRequest inspectionPDFTemplateRequest) throws Exception {



        return ResultVOUtils.success();
    }

    /**
     * 订单，模板检测 code
     */
    @PostMapping("/udiwms/pdf/template/inspection/order/detail/code")
    public BaseResponse inspectionOrderDetailPDFFromTemplateCode(
            @RequestBody InspectionPDFTemplateRequest inspectionPDFTemplateRequest) throws Exception {

        OrderEntity orderEntity = orderService.findById(inspectionPDFTemplateRequest.getOrderId());
        if (orderEntity == null) {
            return ResultVOUtils.error(ResultEnum.DATA_NOT, "未找到订单");
        }

        SystemPDFTemplateEntity systemPDFTemplateEntity = systemPDFTemplateService.selectById("1");
        if (systemPDFTemplateEntity == null) return ResultVOUtils.error(ResultEnum.DATA_NOT, "模板错误");

//        Map<String, Object> rMap = inspectionCustomerPDFTemplate(inspectionPDFTemplateRequest.getCustomerId());
//        if (Integer.parseInt(String.valueOf(rMap.get("code"))) != 0) {
//            return ResultVOUtils.error(ResultEnum.DATA_NOT, String.valueOf(rMap.get("message")));
//        }

        return ResultVOUtils.success();
    }

    /**
     * 订单，模板检测 file
     */
    @PostMapping("/udiwms/pdf/template/inspection/order/detail/file")
    public BaseResponse inspectionOrderDetailPDFFromTemplateFile(
            @RequestBody InspectionPDFTemplateRequest inspectionPDFTemplateRequest) throws Exception {

        OrderEntity orderEntity = orderService.findById(inspectionPDFTemplateRequest.getOrderId());
        if (orderEntity == null) {
            return ResultVOUtils.error(ResultEnum.DATA_NOT, "未找到订单");
        }

        SystemPDFModuleEntity systemPDFModuleEntity = systemPDFModuleService.selectById(1 + "");
        if (systemPDFModuleEntity == null) return ResultVOUtils.error(ResultEnum.DATA_NOT, "所属模块错误");
        SystemPDFTemplateEntity systemPDFTemplateEntity =
                systemPDFTemplateService.selectById(String.valueOf(systemPDFModuleEntity.getTemplateId()));
        if (systemPDFTemplateEntity == null) return ResultVOUtils.error(ResultEnum.DATA_NOT, "模板错误");

        return ResultVOUtils.success();
    }

    /**
     * 检测供应商是否设置模板以及模板是否存在。
     */
    public Map<String, Object> inspectionCustomerPDFTemplate(Long customerId) {

        Map<String, Object> rMap = new HashMap<>();
        rMap.put("code", -1);

        List<SystemPDFTemplateRelevanceEntity> systemPDFTemplateRelevanceEntityList =
                systemPDFTemplateRelevanceService.listByCustomerId(customerId);
        if (systemPDFTemplateRelevanceEntityList.size() < 1) {
            rMap.put("message", "未设置模板");
            return rMap;
        }
        SystemPDFTemplateRelevanceEntity systemPDFTemplateRelevanceEntity = systemPDFTemplateRelevanceEntityList.get(0);

        SystemPDFTemplateRequest systemPDFTemplateRequest = new SystemPDFTemplateRequest();
        systemPDFTemplateRequest.setId(systemPDFTemplateRelevanceEntity.getTemplate_id());

        SystemPDFTemplateEntity systemPDFTemplateEntity =
                systemPDFTemplateService.findSystemPDFTemplate(systemPDFTemplateRequest);
        if (systemPDFTemplateEntity == null) {
            rMap.put("message", "模板错误");
            return rMap;
        }

        rMap.put("code", 0);
        rMap.put("message", "成功");
        rMap.put("data", systemPDFTemplateEntity.getParam());
        return rMap;
    }
}