package com.glxp.api.admin.dao.info;

import com.glxp.api.admin.entity.info.SystemPDFTemplateRelevanceEntity;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;


@Mapper
public interface SystemPDFTemplateRelevanceDao {

    /**
     * 根据 customerId 查询
     * @param customerId 传入的 customerId
     * @return
     */
    List<SystemPDFTemplateRelevanceEntity> listByCustomerId(Long customerId);

    /**
     * 根据 多个 customerId 查询
     * @param customerIds 传入的 customerIds
     * @return
     */
    List<SystemPDFTemplateRelevanceEntity> listByCustomerIdIn(List<Long> customerIds);

    /**
     * 根据 template_id 查询 customer_id
     * @param templateId 传入的 templateId
     * @return
     */
    List<SystemPDFTemplateRelevanceEntity> listByTemplateId(int templateId);

    /**
     * 批量插入
     * @param systemPDFTemplateRelevanceEntityList
     * @return
     */
    int insertSystemPDFTemplateRelevanceAll(List<SystemPDFTemplateRelevanceEntity> systemPDFTemplateRelevanceEntityList);

    boolean insert(SystemPDFTemplateRelevanceEntity systemPDFTemplateRelevanceEntity);


    /**
     * 根据 customerId 删除
     * @param customerId
     * @return
     */
    boolean deleteByCustomerId(Long customerId);
}
