package com.glxp.api.admin.httpclient;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.TypeReference;
import com.glxp.api.admin.req.inventory.ErpOnhandRequest;
import com.glxp.api.admin.res.PageSimpleResponse;
import com.glxp.api.admin.res.inventory.ErpInvProductResponse;
import com.glxp.api.admin.res.inventory.ErpOnHandResponse;
import com.glxp.api.admin.util.HttpClient;
import com.glxp.api.common.res.BaseResponse;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ErpInvClient {


    public List<ErpOnHandResponse> getOnHand(ErpOnhandRequest onhandRequest, String url) {

        BaseResponse<PageSimpleResponse<ErpOnHandResponse>> onHandsResponse = getOnHandResponse(onhandRequest, url);
        List<ErpOnHandResponse> erpOnHandResponses = onHandsResponse.getData().getList();
        return erpOnHandResponses;
    }

    public BaseResponse<PageSimpleResponse<ErpOnHandResponse>> getOnHandResponse(ErpOnhandRequest onhandRequest, String url) {

        Map<String, Object> paramMap = new HashMap<>(16);
        if (onhandRequest.getBatchNo() != null && !onhandRequest.getBatchNo().equals(""))
            paramMap.put("batchNo", onhandRequest.getBatchNo());
        if (onhandRequest.getWarehouseCode() != null && !onhandRequest.getWarehouseCode().equals(""))
            paramMap.put("warehouseCode", onhandRequest.getWarehouseCode());
        if (onhandRequest.getInventoryCode() != null && !onhandRequest.getInventoryCode().equals(""))
            paramMap.put("inventoryCode", onhandRequest.getInventoryCode());
        if (onhandRequest.getPage() != null)
            paramMap.put("page", onhandRequest.getPage());
        if (onhandRequest.getLimit() != null)
            paramMap.put("limit", onhandRequest.getLimit());
        String response = HttpClient.mipsGet(url, paramMap);
        try {
            BaseResponse<PageSimpleResponse<ErpOnHandResponse>> onHandsResponse =
                    JSONObject.parseObject(response, new TypeReference<BaseResponse<PageSimpleResponse<ErpOnHandResponse>>>() {
                    });
            return onHandsResponse;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }

    public BaseResponse<PageSimpleResponse<ErpInvProductResponse>> getInvPrdoductResponse(ErpOnhandRequest onhandRequest, String url) {

        Map<String, Object> paramMap = new HashMap<>(16);
        if (onhandRequest.getBatchNo() != null && !onhandRequest.getBatchNo().equals(""))
            paramMap.put("batchNo", onhandRequest.getBatchNo());
        if (onhandRequest.getWarehouseCode() != null && !onhandRequest.getWarehouseCode().equals(""))
            paramMap.put("warehouseCode", onhandRequest.getWarehouseCode());
        if (onhandRequest.getInventoryCode() != null && !onhandRequest.getInventoryCode().equals(""))
            paramMap.put("inventoryCode", onhandRequest.getInventoryCode());
        if (onhandRequest.getInventoryName() != null && !onhandRequest.getInventoryName().equals(""))
            paramMap.put("inventoryName", onhandRequest.getInventoryName());
        if (onhandRequest.getSpec() != null && !onhandRequest.getSpec().equals(""))
            paramMap.put("spec", onhandRequest.getSpec());
        if (onhandRequest.getRegisterCertNo() != null && !onhandRequest.getRegisterCertNo().equals(""))
            paramMap.put("registerCertNo", onhandRequest.getRegisterCertNo());
        if (onhandRequest.getManufactory() != null && !onhandRequest.getManufactory().equals(""))
            paramMap.put("manufactory", onhandRequest.getManufactory());

        if (onhandRequest.getFilterCount() != null && !onhandRequest.getFilterCount().equals(""))
            paramMap.put("filterCount", onhandRequest.getFilterCount());
        if (onhandRequest.getPage() != null)
            paramMap.put("page", onhandRequest.getPage());
        if (onhandRequest.getLimit() != null)
            paramMap.put("limit", onhandRequest.getLimit());
        String response = HttpClient.mipsGet(url, paramMap);
        try {
            BaseResponse<PageSimpleResponse<ErpInvProductResponse>> onHandsResponse =
                    JSONObject.parseObject(response, new TypeReference<BaseResponse<PageSimpleResponse<ErpInvProductResponse>>>() {
                    });
            return onHandsResponse;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }

    public List<ErpInvProductResponse> getInvPrdoduct(ErpOnhandRequest onhandRequest, String url) {
        BaseResponse<PageSimpleResponse<ErpInvProductResponse>> responseBaseResponse = getInvPrdoductResponse(onhandRequest, url);
        List<ErpInvProductResponse> responseList = responseBaseResponse.getData().getList();
        return responseList;
    }
}
