package com.glxp.api.admin.httpclient;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.TypeReference;
import com.glxp.api.admin.entity.basic.UdiInfoEntity;
import com.glxp.api.admin.util.HttpClient;
import com.glxp.api.common.res.BaseResponse;
import com.glxp.api.common.util.ResultVOUtils;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * 获取国家UDI同步库信息
 */
public class UdiDlHttpClient {
    String udiUrl;

    public UdiDlHttpClient(String udiUrl) {
        this.udiUrl = udiUrl;
    }

    public List<UdiInfoEntity> getUdiByUuid(String uuid) {
        Map<String, Object> paramMap = new HashMap<>(16);
        paramMap.put("page", 1);
        paramMap.put("limit", 100);
        paramMap.put("uuid", uuid);
        String response = HttpClient.mipsGet(udiUrl + "/udidl/device/filterByUuid", paramMap);
        try {
            BaseResponse<List<UdiInfoEntity>> udiDlDeviceResponse = (BaseResponse<List<UdiInfoEntity>>) JSONObject.parseObject(response, BaseResponse.class);
            List<UdiInfoEntity> udiInfoEntities = udiDlDeviceResponse.getData();
            return udiInfoEntities;
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    public List<UdiInfoEntity> getUdiByDi(String key) {
        Map<String, Object> paramMap = new HashMap<>(16);
        paramMap.put("page", 1);
        paramMap.put("limit", 100);
        paramMap.put("nameCode", key);
        String response = HttpClient.mipsGet(udiUrl + "/udidl/device/filterByNameCode", paramMap);
        try {
            BaseResponse<List<UdiInfoEntity>> udiDlDeviceResponse =
                    JSONObject.parseObject(response, new TypeReference<BaseResponse<List<UdiInfoEntity>>>() {

                    });
            if (udiDlDeviceResponse != null && udiDlDeviceResponse.getCode() == 20000) {
                List<UdiInfoEntity> udiInfoEntities = udiDlDeviceResponse.getData();
                return udiInfoEntities;
            }

        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
        return null;
    }
}
