package com.glxp.api.admin.service.basic.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.basic.BasicThirdSysDetailDao;
import com.glxp.api.admin.entity.basic.BasicThirdSysDetailEntity;
import com.glxp.api.admin.entity.basic.BasicThirdSysDetailEntity;
import com.glxp.api.admin.req.basic.FilterBasicThirdSysDetailRequest;
import com.glxp.api.admin.service.basic.BasicThirdSysDetailService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class BasicThirdSysDetailServiceImpl implements BasicThirdSysDetailService {

    @Resource
    BasicThirdSysDetailDao basicThirdSysDetailDao;

    @Override
    public boolean updateBasicThirdSysDetail(BasicThirdSysDetailEntity basicThirdSysEntity) {
        return basicThirdSysDetailDao.updateBasicThirdSysDetail(basicThirdSysEntity);
    }

    @Override
    public BasicThirdSysDetailEntity selectByKey(String key, String thirdSys) {
        return  basicThirdSysDetailDao.selectByKey(key,thirdSys);
    }

    @Override
    public List<BasicThirdSysDetailEntity> filterBasicThirdSysDetail(FilterBasicThirdSysDetailRequest filterBasicThirdSysDetailRequest) {
        if (filterBasicThirdSysDetailRequest == null) {
            return Collections.emptyList();
        }

        if (filterBasicThirdSysDetailRequest.getPage() != null) {
            int offset = (filterBasicThirdSysDetailRequest.getPage() - 1) * filterBasicThirdSysDetailRequest.getLimit();
            PageHelper.offsetPage(offset, filterBasicThirdSysDetailRequest.getLimit());
        }
        List<BasicThirdSysDetailEntity> data = basicThirdSysDetailDao.filterBasicThirdSysDetail(filterBasicThirdSysDetailRequest);
        return data;
    }
}
