package com.glxp.api.admin.service.basic.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.basic.BussinessLocalTypeDao;
import com.glxp.api.admin.entity.basic.BussinessLocalTypeEntity;
import com.glxp.api.admin.entity.basic.BussinessTypeEntity;
import com.glxp.api.admin.req.basic.BussinessLocalTypeFilterRequest;
import com.glxp.api.admin.req.receipt.BussinessTypeFilterRequest;
import com.glxp.api.admin.service.basic.BussinessLocalTypeService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class BussinessLocalTypeServiceImpl implements BussinessLocalTypeService {

    @Resource
    BussinessLocalTypeDao bussinessLocalTypeDao;

    @Override
    public List<BussinessLocalTypeEntity> filterList(BussinessLocalTypeFilterRequest bussinessTypeFilterRequest) {
        if (bussinessTypeFilterRequest == null) {
            return Collections.emptyList();
        }
        if (bussinessTypeFilterRequest.getPage() != null) {
            int offset = (bussinessTypeFilterRequest.getPage() - 1) * bussinessTypeFilterRequest.getLimit();
            PageHelper.offsetPage(offset, bussinessTypeFilterRequest.getLimit());
        }
        List<BussinessLocalTypeEntity> data = bussinessLocalTypeDao.filterList(bussinessTypeFilterRequest);
        return data;
    }

    @Override
    public BussinessLocalTypeEntity findBTByAction(String action) {
        BussinessLocalTypeFilterRequest bussinessTypeFilterRequest = new BussinessLocalTypeFilterRequest();
        bussinessTypeFilterRequest.setAction(action);
        List<BussinessLocalTypeEntity> data = bussinessLocalTypeDao.filterList(bussinessTypeFilterRequest);
        if (data != null && data.size() > 0) {
            return data.get(0);
        }
        return null;
    }

    @Override
    public BussinessLocalTypeEntity findBTByName(String name) {
        BussinessLocalTypeFilterRequest bussinessTypeFilterRequest = new BussinessLocalTypeFilterRequest();
        bussinessTypeFilterRequest.setName(name);
        List<BussinessLocalTypeEntity> data = bussinessLocalTypeDao.filterList(bussinessTypeFilterRequest);
        if (data != null && data.size() > 0) {
            return data.get(0);
        }
        return null;
    }

    @Override
    public boolean updateBusLocalType(BussinessLocalTypeEntity bussinessTypeEntity) {
        return bussinessLocalTypeDao.updateBusLocalType(bussinessTypeEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return bussinessLocalTypeDao.deleteById(id);
    }
}
