package com.glxp.api.admin.service.basic.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.basic.CorpExportLogDao;
import com.glxp.api.admin.entity.basic.CorpExportLogEntity;
import com.glxp.api.admin.entity.basic.UdiInfoExportLogEntity;
import com.glxp.api.admin.req.basic.FilterUdiEpLogRequest;
import com.glxp.api.admin.service.basic.CorpExportLogService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class CorpExportLogServiceImpl implements CorpExportLogService {

    @Resource
    CorpExportLogDao corpExportLogDao;

    @Override
    public CorpExportLogEntity selectByGenKey(String genKey) {
        FilterUdiEpLogRequest filterUdiEpLogRequest = new FilterUdiEpLogRequest();
        filterUdiEpLogRequest.setGenKey(genKey);
        List<CorpExportLogEntity> corpExportLogEntities = corpExportLogDao.filterCorpExportLog(filterUdiEpLogRequest);
        if (corpExportLogEntities != null && corpExportLogEntities.size() > 0) {
            return corpExportLogEntities.get(0);
        }
        return null;
    }

    @Override
    public List<CorpExportLogEntity> filterCorpExportLog(FilterUdiEpLogRequest filterUdiEpLogRequest) {
        if (filterUdiEpLogRequest == null) {
            return Collections.emptyList();
        }
        if (filterUdiEpLogRequest.getPage() != null) {
            int offset = (filterUdiEpLogRequest.getPage() - 1) * filterUdiEpLogRequest.getLimit();
            PageHelper.offsetPage(offset, filterUdiEpLogRequest.getLimit());
        }
        List<CorpExportLogEntity> data = corpExportLogDao.filterCorpExportLog(filterUdiEpLogRequest);
        return data;
    }

    @Override
    public boolean insertCorpExportLog(CorpExportLogEntity corpExportLogEntity) {
        return corpExportLogDao.insertCorpExportLog(corpExportLogEntity);
    }

    @Override
    public boolean updateCorpExportLog(CorpExportLogEntity corpExportLogEntity) {
        return corpExportLogDao.updateCorpExportLog(corpExportLogEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return corpExportLogDao.deleteById(id);
    }
}
