package com.glxp.api.admin.service.basic.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.basic.CorpImportDetailDao;
import com.glxp.api.admin.entity.basic.CorpImportDetailEntity;
import com.glxp.api.admin.entity.basic.UdiInfoImportDetailEntity;
import com.glxp.api.admin.req.basic.FilterUdiIpLogRequest;
import com.glxp.api.admin.service.basic.CorpImportDetailService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class CorpImportDetailServiceImpl implements CorpImportDetailService {
    @Resource
    CorpImportDetailDao corpImportDetailDao;

    @Override
    public List<CorpImportDetailEntity> filterCorpImport(FilterUdiIpLogRequest filterUdiIpLogRequest) {
        if (filterUdiIpLogRequest == null) {
            return Collections.emptyList();
        }
        if (filterUdiIpLogRequest.getPage() != null) {
            int offset = (filterUdiIpLogRequest.getPage() - 1) * filterUdiIpLogRequest.getLimit();
            PageHelper.offsetPage(offset, filterUdiIpLogRequest.getLimit());
        }
        List<CorpImportDetailEntity> data = corpImportDetailDao.filterCorpImport(filterUdiIpLogRequest);
        return data;
    }

    @Override
    public boolean insertCorpImport(CorpImportDetailEntity corpImportDetailEntity) {
        return corpImportDetailDao.insertCorpImport(corpImportDetailEntity);
    }

    @Override
    public boolean updateCorpImport(CorpImportDetailEntity corpImportDetailEntity) {
        return corpImportDetailDao.updateCorpImport(corpImportDetailEntity);
    }

    @Override
    public boolean insertCorpImports(List<CorpImportDetailEntity> corpImportDetailEntities) {
        return corpImportDetailDao.insertCorpImports(corpImportDetailEntities);
    }

    @Override
    public boolean deleteById(String id) {
        return corpImportDetailDao.deleteById(id);
    }

    @Override
    public boolean deleteByGenkey(String genKey) {
        return corpImportDetailDao.deleteByGenkey(genKey);
    }
}
