package com.glxp.api.admin.service.basic.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.basic.CorpImportLogDao;
import com.glxp.api.admin.entity.basic.CorpImportLogEntity;
import com.glxp.api.admin.entity.basic.UdiInfoImportLogEntity;
import com.glxp.api.admin.req.basic.FilterUdiIpLogRequest;
import com.glxp.api.admin.service.basic.CorpImportLogService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class CorpImportLogServiceImpl implements CorpImportLogService {

    @Resource
    CorpImportLogDao corpImportLogDao;

    @Override
    public CorpImportLogEntity selectByGenKey(String genKey) {
        FilterUdiIpLogRequest filterUdiIpLogRequest = new FilterUdiIpLogRequest();
        filterUdiIpLogRequest.setGenKey(genKey);
        List<CorpImportLogEntity> data = corpImportLogDao.filterImportLog(filterUdiIpLogRequest);
        if (data != null && data.size() > 0) {
            return data.get(0);
        }
        return null;
    }

    @Override
    public List<CorpImportLogEntity> filterImportLog(FilterUdiIpLogRequest filterUdiIpLogRequest) {
        if (filterUdiIpLogRequest == null) {
            return Collections.emptyList();
        }
        if (filterUdiIpLogRequest.getPage() != null) {
            int offset = (filterUdiIpLogRequest.getPage() - 1) * filterUdiIpLogRequest.getLimit();
            PageHelper.offsetPage(offset, filterUdiIpLogRequest.getLimit());
        }
        List<CorpImportLogEntity> data = corpImportLogDao.filterImportLog(filterUdiIpLogRequest);
        return data;
    }

    @Override
    public boolean insertImportLog(CorpImportLogEntity corpImportLogEntity) {
        return corpImportLogDao.insertImportLog(corpImportLogEntity);
    }

    @Override
    public boolean updateImportLog(CorpImportLogEntity corpImportLogEntity) {
        return corpImportLogDao.updateImportLog(corpImportLogEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return corpImportLogDao.deleteById(id);
    }
}
