package com.glxp.api.admin.service.basic.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.basic.UdiInfoExportLogDao;
import com.glxp.api.admin.entity.basic.UdiInfoExportLogEntity;
import com.glxp.api.admin.req.basic.FilterUdiEpLogRequest;
import com.glxp.api.admin.req.basic.FilterUdiIpLogRequest;
import com.glxp.api.admin.service.basic.UdiInfoExportLogService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class UdiInfoExportLogServiceImpl implements UdiInfoExportLogService {

    @Resource
    UdiInfoExportLogDao udiInfoExportLogDao;

    @Override
    public UdiInfoExportLogEntity selectByGenKey(String genKey) {
        FilterUdiEpLogRequest filterUdiEpLogRequest = new FilterUdiEpLogRequest();
        filterUdiEpLogRequest.setGenKey(genKey);
        List<UdiInfoExportLogEntity> data = udiInfoExportLogDao.filterUdiInfoExportLog(filterUdiEpLogRequest);
        if (data != null)
            return data.get(0);
        else
            return null;
    }

    @Override
    public List<UdiInfoExportLogEntity> filterUdiInfoExportLog(FilterUdiEpLogRequest filterInCodeLogRequest) {
        if (filterInCodeLogRequest == null) {
            return Collections.emptyList();
        }
        if (filterInCodeLogRequest.getPage() != null) {
            int offset = (filterInCodeLogRequest.getPage() - 1) * filterInCodeLogRequest.getLimit();
            PageHelper.offsetPage(offset, filterInCodeLogRequest.getLimit());
        }
        List<UdiInfoExportLogEntity> data = udiInfoExportLogDao.filterUdiInfoExportLog(filterInCodeLogRequest);
        return data;
    }

    @Override
    public boolean insertUdiInfoExportLog(UdiInfoExportLogEntity udiInfoImportEntity) {
        return udiInfoExportLogDao.insertUdiInfoExportLog(udiInfoImportEntity);
    }

    @Override
    public boolean updateUdiInfoExportLog(UdiInfoExportLogEntity udiInfoImportEntity) {
        return udiInfoExportLogDao.updateUdiInfoExportLog(udiInfoImportEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return udiInfoExportLogDao.deleteById(id);
    }
}
