package com.glxp.api.admin.service.basic.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.basic.UdiInfoImportDetailDao;
import com.glxp.api.admin.entity.basic.UdiInfoImportDetailEntity;
import com.glxp.api.admin.req.basic.FilterUdiIpLogRequest;
import com.glxp.api.admin.service.basic.UdiInfoImportDetailService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class UdiInfoImportDetailServiceImpl implements UdiInfoImportDetailService {

    @Resource
    UdiInfoImportDetailDao udiInfoImportDao;


    @Override
    public List<UdiInfoImportDetailEntity> filterUdiInfoImport(FilterUdiIpLogRequest filterInCodeLogRequest) {
        if (filterInCodeLogRequest == null) {
            return Collections.emptyList();
        }
        if (filterInCodeLogRequest.getPage() != null) {
            int offset = (filterInCodeLogRequest.getPage() - 1) * filterInCodeLogRequest.getLimit();
            PageHelper.offsetPage(offset, filterInCodeLogRequest.getLimit());
        }
        List<UdiInfoImportDetailEntity> data = udiInfoImportDao.filterUdiInfoImport(filterInCodeLogRequest);
        return data;

    }


    @Override
    public boolean insertUdiInfoImport(UdiInfoImportDetailEntity udiInfoImportEntity) {
        return udiInfoImportDao.insertUdiInfoImport(udiInfoImportEntity);
    }

    @Override
    public boolean updateUdiInfoImport(UdiInfoImportDetailEntity udiInfoImportEntity) {
        return udiInfoImportDao.updateUdiInfoImport(udiInfoImportEntity);
    }

    @Override
    public boolean insertUdiInfoImports(List<UdiInfoImportDetailEntity> udiInfoImportEntities) {
        return udiInfoImportDao.insertUdiInfoImports(udiInfoImportEntities);
    }

    @Override
    public boolean deleteById(String id) {
        return udiInfoImportDao.deleteById(id);
    }

    @Override
    public boolean deleteByGenkey(String genKey) {
        return udiInfoImportDao.deleteByGenkey(genKey);
    }
}
