package com.glxp.api.admin.service.basic.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.basic.UdiInfoImportLogDao;
import com.glxp.api.admin.entity.basic.UdiInfoImportLogEntity;
import com.glxp.api.admin.req.basic.FilterUdiIpLogRequest;
import com.glxp.api.admin.service.basic.UdiInfoImportLogService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class UdiInfoImportLogServiceImpl implements UdiInfoImportLogService {
    @Resource
    UdiInfoImportLogDao udiInfoImportLogDao;

    @Override
    public UdiInfoImportLogEntity selectByGenKey(String genKey) {
        FilterUdiIpLogRequest filterUdiIpLogRequest = new FilterUdiIpLogRequest();
        filterUdiIpLogRequest.setGenKey(genKey);
        List<UdiInfoImportLogEntity> data = udiInfoImportLogDao.filterImportLog(filterUdiIpLogRequest);
        if (data != null && data.size() > 0) {
            return data.get(0);
        }
        return null;
    }

    @Override
    public List<UdiInfoImportLogEntity> filterImportLog(FilterUdiIpLogRequest filterUdiIpLogRequest) {
        if (filterUdiIpLogRequest == null) {
            return Collections.emptyList();
        }
        if (filterUdiIpLogRequest.getPage() != null) {
            int offset = (filterUdiIpLogRequest.getPage() - 1) * filterUdiIpLogRequest.getLimit();
            PageHelper.offsetPage(offset, filterUdiIpLogRequest.getLimit());
        }
        List<UdiInfoImportLogEntity> data = udiInfoImportLogDao.filterImportLog(filterUdiIpLogRequest);
        return data;
    }

    @Override
    public boolean insertImportLog(UdiInfoImportLogEntity udiInfoImportLogEntity) {
        return udiInfoImportLogDao.insertImportLog(udiInfoImportLogEntity);
    }

    @Override
    public boolean updateImportLog(UdiInfoImportLogEntity udiInfoImportLogEntity) {
        return udiInfoImportLogDao.updateImportLog(udiInfoImportLogEntity);
    }


    @Override
    public boolean deleteById(String id) {
        return udiInfoImportLogDao.deleteById(id);
    }
}
