package com.glxp.api.admin.service.basic.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.basic.UdiInfoDao;
import com.glxp.api.admin.entity.basic.UdiInfoEntity;
import com.glxp.api.admin.req.basic.FilterUdiInfoRequest;
import com.glxp.api.admin.service.basic.UdiInfoService;
import com.glxp.api.admin.util.FilterUdiUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class UdiInfoServiceImpl implements UdiInfoService {

    @Resource
    UdiInfoDao udiInfoDao;

    @Override
    public List<UdiInfoEntity> filterUdiInfo(FilterUdiInfoRequest filterUdiInfoRequest) {
        if (filterUdiInfoRequest == null) {
            return Collections.emptyList();
        }
        int offset = (filterUdiInfoRequest.getPage() - 1) * filterUdiInfoRequest.getLimit();
        PageHelper.offsetPage(offset, filterUdiInfoRequest.getLimit());
        List<UdiInfoEntity> data = udiInfoDao.filterUdiInfo(filterUdiInfoRequest);
        return data;
    }

    @Override
    public List<UdiInfoEntity> filterAllUdiInfo(FilterUdiInfoRequest filterUdiInfoRequest) {
        if (filterUdiInfoRequest == null) {
            return Collections.emptyList();
        }
        List<UdiInfoEntity> data = udiInfoDao.filterUdiInfo(filterUdiInfoRequest);
        return data;
    }

    @Override
    public UdiInfoEntity findByNameCode(String nameCode) {
        String prefix = FilterUdiUtils.getDiStr(nameCode);
        return udiInfoDao.findByNameCode(prefix);
    }

    @Override
    public UdiInfoEntity findByUuid(String uuid) {
        return udiInfoDao.findByUuid(uuid);
    }

    @Override
    public List<UdiInfoEntity> findByUuids(String uuid) {
        return udiInfoDao.findByUuids(uuid);
    }

    @Override
    public boolean insertUdiInfo(UdiInfoEntity udiInfoEntity) {
        return udiInfoDao.insertUdiInfo(udiInfoEntity);
    }

    @Override
    public boolean insertUdiInfos(List<UdiInfoEntity> udiInfoEntities) {
        return udiInfoDao.insertUdiInfos(udiInfoEntities);
    }

    @Override
    public boolean updateUdiInfo(UdiInfoEntity udiInfoEntity) {
        return udiInfoDao.updateUdiInfo(udiInfoEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return udiInfoDao.deleteById(id);
    }

    @Override
    public boolean deleteByUuid(String uuid) {
        return udiInfoDao.deleteByUuid(uuid);
    }
}
