package com.glxp.api.admin.service.basic.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.basic.UnitMaintainDao;
import com.glxp.api.admin.entity.basic.UnitMaintainEntity;
import com.glxp.api.admin.req.basic.BasicUnitMaintainFilterRequest;
import com.glxp.api.admin.req.basic.FilterUdiInfoRequest;
import com.glxp.api.admin.res.basic.UdiRelevanceResponse;
import com.glxp.api.admin.service.basic.UnitMaintainService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class UnitMaintainServiceImpl implements UnitMaintainService {

    @Resource
    UnitMaintainDao unitMaintainDao;

    @Override
    public List<UnitMaintainEntity> filterList(BasicUnitMaintainFilterRequest unitMaintainFilterRequest) {
        if (unitMaintainFilterRequest == null) {
            return Collections.emptyList();
        }
        if (unitMaintainFilterRequest.getPage() != null) {
            int offset = (unitMaintainFilterRequest.getPage() - 1) * unitMaintainFilterRequest.getLimit();
            PageHelper.offsetPage(offset, unitMaintainFilterRequest.getLimit());
        }

        List<UnitMaintainEntity> data = unitMaintainDao.filterList(unitMaintainFilterRequest);
        return data;
    }

    @Override
    public boolean insertUnitMaintain(UnitMaintainEntity unitMaintainEntity) {
        return unitMaintainDao.insertUnitMaintain(unitMaintainEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return unitMaintainDao.deleteById(id);
    }

    @Override
    public boolean isExit() {
        BasicUnitMaintainFilterRequest filterUdiInfoRequest = new BasicUnitMaintainFilterRequest();
        filterUdiInfoRequest.setPage(1);
        filterUdiInfoRequest.setLimit(1);
        List<UnitMaintainEntity> data = filterList(filterUdiInfoRequest);
        if (data != null && data.size() > 0) {
            return true;
        }
        return false;
    }

    @Override
    public UnitMaintainEntity selectById(String id) {
        return unitMaintainDao.selectById(id);
    }
}
