package com.glxp.api.admin.service.info.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.info.SystemParamConfigDao;
import com.glxp.api.admin.entity.info.SystemParamConfigEntity;
import com.glxp.api.admin.req.info.SystemParamConfigRequest;
import com.glxp.api.admin.req.info.SystemParamConfigSaveRequest;
import com.glxp.api.admin.service.info.SystemParamConfigService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

@Service
public class SystemParamConfigServiceImpl implements SystemParamConfigService {
    @Resource
    SystemParamConfigDao systemParamConfigDao;

    @Override
    public List<SystemParamConfigEntity> queryPage(SystemParamConfigRequest SystemParamConfigRequest) {
        int offset = (SystemParamConfigRequest.getPage() - 1) * SystemParamConfigRequest.getLimit();
        PageHelper.offsetPage(offset, SystemParamConfigRequest.getLimit());
        List<SystemParamConfigEntity> list = systemParamConfigDao.queryPage(SystemParamConfigRequest);
        return list;
    }

    @Override
    public SystemParamConfigEntity selectSystemParamConfig() {
        SystemParamConfigRequest systemParamConfigRequest = new SystemParamConfigRequest();
        systemParamConfigRequest.setId(1);
        return systemParamConfigDao.findSystemParamConfig(systemParamConfigRequest);
    }

    @Override
    public SystemParamConfigEntity findSystemParamConfig(SystemParamConfigRequest systemParamConfigRequest) {
        return systemParamConfigDao.findSystemParamConfig(systemParamConfigRequest);
    }

    @Override
    public SystemParamConfigEntity selectByParamName(SystemParamConfigRequest systemParamConfigRequest) {
        return systemParamConfigDao.selectByParamName(systemParamConfigRequest);
    }

    @Override
    public SystemParamConfigEntity selectByParamKey(String key) {
        return systemParamConfigDao.selectByParamKey(key);
    }

    @Override
    public String selectValueByParamKey(String key) {
        SystemParamConfigEntity systemParamConfigEntity = systemParamConfigDao.selectByParamKey(key);
        if(systemParamConfigEntity!=null ){
            return systemParamConfigEntity.getParamValue();
        }
        return null;
    }

    @Override
    public boolean updateById(SystemParamConfigSaveRequest systemParamConfigSaveRequest) {

        return systemParamConfigDao.updateById(systemParamConfigSaveRequest);
    }

    @Override
    public boolean updateParentId(SystemParamConfigSaveRequest systemParamConfigSaveRequest) {

        return systemParamConfigDao.updateParentId(systemParamConfigSaveRequest);
    }

    @Override
    public boolean insert(SystemParamConfigEntity systemParamConfigEntity) {
        return systemParamConfigDao.insert(systemParamConfigEntity);
    }
}
