package com.glxp.api.admin.service.info.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.info.ThirdSysApiDao;
import com.glxp.api.admin.entity.info.ThirdSysApiEntity;
import com.glxp.api.admin.req.info.FilterSysApiRequest;
import com.glxp.api.admin.service.info.ThirdSysApiService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class ThirdSysApiServiceImpl implements ThirdSysApiService {
    @Resource
    ThirdSysApiDao thirdSysApiDao;

    @Override
    public List<ThirdSysApiEntity> findSysApi(FilterSysApiRequest filterSysApiRequest) {

        if (filterSysApiRequest == null) {
            return Collections.emptyList();
        }
        if (filterSysApiRequest.getPage() != null) {
            int offset = (filterSysApiRequest.getPage() - 1) * filterSysApiRequest.getLimit();
            PageHelper.offsetPage(offset, filterSysApiRequest.getLimit());
        }
        return thirdSysApiDao.findSysApi(filterSysApiRequest);
    }

    @Override
    public boolean modifySysApi(ThirdSysApiEntity thirdSysApiEntity) {
        return false;
    }
}
