package com.glxp.api.admin.service.inout;

import com.glxp.api.admin.entity.inout.OrderEntity;
import com.glxp.api.admin.entity.inout.WarehouseEntity;
import com.glxp.api.admin.req.inout.OrderFilterRequest;
import com.glxp.api.admin.req.inout.OrderQueryRequest;

import java.util.List;

public interface OrderService {

    List<OrderEntity> listOrders(OrderQueryRequest orderQueryRequest);

    boolean insertOrder(OrderEntity orderEntity);

    boolean updateOrder(OrderEntity orderEntity);


    List<OrderEntity> listOrderRepeat(OrderQueryRequest orderQueryRequest);

    boolean deleteByOrderId(String orderId);

    boolean deleteById(String id);

    boolean updateUnit(OrderEntity orderEntity);

    boolean updateOrderStatus(String orderId, Integer status);

    boolean updateExportStatus(String orderId, Integer exportStatus);

    boolean updateSignStatus(String orderId, Integer signStatus);

    boolean updateContrastStatus(String orderId, String contrastStatus);

    boolean updateRemark(String orderId, String remark);

    List<OrderEntity> findAllOrders(OrderFilterRequest orderFilterRequest);

    List<OrderEntity> filterList(OrderFilterRequest orderFilterRequest);

    OrderEntity findOne(OrderFilterRequest orderFilterRequest);

    OrderEntity findById(String orderId);

    List<String> findCodesById(String orderId);

    List<OrderEntity> filterListByCode(List<WarehouseEntity> warehouseEntityList);
}
