package com.glxp.api.admin.service.inout.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.inout.CodesDao;
import com.glxp.api.admin.dao.inout.CodesTempDao;
import com.glxp.api.admin.entity.inout.WarehouseEntity;
import com.glxp.api.admin.req.inout.WarehouseQueryRequest;
import com.glxp.api.admin.service.inout.CodesTempService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class CodesTempServiceImpl implements CodesTempService {


    @Resource
    CodesTempDao codesTempDao;

    @Override
    public int insertCodesTemp(List<WarehouseEntity> warehouseEntities) {
        return codesTempDao.insertCodesTemp(warehouseEntities);
    }

    @Override
    public int deleteCodesTemp(List<Long> ids) {
        return codesTempDao.deleteCodesTemp(ids);
    }

    @Override
    public List<WarehouseEntity> findByOrderId(WarehouseQueryRequest warehouseQueryRequest) {
        if (warehouseQueryRequest == null) {
            return Collections.emptyList();
        }
        if (warehouseQueryRequest.getPage() != null) {
            int offset = (warehouseQueryRequest.getPage() - 1) * warehouseQueryRequest.getLimit();
            PageHelper.offsetPage(offset, warehouseQueryRequest.getLimit());
        }
        return codesTempDao.findByOrderId(warehouseQueryRequest);
    }
}
