package com.glxp.api.admin.service.inventory.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.inventory.InCodeLogDao;
import com.glxp.api.admin.entity.inventory.InCodeLogEntity;
import com.glxp.api.admin.entity.inventory.StockPrintEntity;
import com.glxp.api.admin.req.inventory.FilterInCodeLogRequest;
import com.glxp.api.admin.service.inventory.InCodeLogService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class InCodeLogServiceImpl implements InCodeLogService {
    @Resource
    InCodeLogDao inCodeLogDao;

    @Override
    public List<InCodeLogEntity> filterInCodeLog(FilterInCodeLogRequest filterInCodeLogRequest) {
        if (filterInCodeLogRequest == null) {
            return Collections.emptyList();
        }
        if (filterInCodeLogRequest.getPage() != null) {
            int offset = (filterInCodeLogRequest.getPage() - 1) * filterInCodeLogRequest.getLimit();
            PageHelper.offsetPage(offset, filterInCodeLogRequest.getLimit());
        }
        List<InCodeLogEntity> data = inCodeLogDao.filterInCodeLog(filterInCodeLogRequest);
        return data;
    }

    @Override
    public InCodeLogEntity selectByGenKey(String genKey) {
        FilterInCodeLogRequest filterInCodeLogRequest = new FilterInCodeLogRequest();
        filterInCodeLogRequest.setGenKey(genKey);
        List<InCodeLogEntity> data = inCodeLogDao.filterInCodeLog(filterInCodeLogRequest);
        if (data != null)
            return data.get(0);
        else return null;
    }

    @Override
    public boolean insertInCodeLog(InCodeLogEntity inCodeLogEntity) {
        return inCodeLogDao.insertInCodeLog(inCodeLogEntity);
    }

    @Override
    public boolean updateInCodeLog(InCodeLogEntity inCodeLogEntity) {
        return inCodeLogDao.updateInCodeLog(inCodeLogEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return inCodeLogDao.deleteById(id);
    }
}
