package com.glxp.api.admin.service.inventory.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.inventory.InvOrderCheckDao;
import com.glxp.api.admin.entity.inout.StockCheckEntity;
import com.glxp.api.admin.req.inout.FilterStockCheckRequest;
import com.glxp.api.admin.service.inventory.InvOrderCheckService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class InvOrderCheckServiceImpl implements InvOrderCheckService {

    @Resource
    InvOrderCheckDao stockCheckDao;


    @Override
    public List<StockCheckEntity> filterStockCheck(FilterStockCheckRequest filterStockCheckRequest) {
        if (filterStockCheckRequest == null) {
            return Collections.emptyList();
        }
        if(filterStockCheckRequest.getPage()!=null){
            int offset = (filterStockCheckRequest.getPage() - 1) * filterStockCheckRequest.getLimit();
            PageHelper.offsetPage(offset, filterStockCheckRequest.getLimit());
        }

        List<StockCheckEntity> data = stockCheckDao.filterStockCheck(filterStockCheckRequest);
        return data;
    }

    @Override
    public boolean insertStockCheck(StockCheckEntity stockCheckEntity) {
        return stockCheckDao.insertStockCheck(stockCheckEntity);
    }

    @Override
    public boolean updateStockCheck(StockCheckEntity stockCheckEntity) {
        return stockCheckDao.updateStockCheck(stockCheckEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return stockCheckDao.deleteById(id);
    }
}
