package com.glxp.api.admin.service.inventory.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.inventory.InvStockPrintDao;
import com.glxp.api.admin.entity.inventory.StockPrintEntity;
import com.glxp.api.admin.req.basic.FilterStockprintRequest;
import com.glxp.api.admin.service.inventory.InvStockPrintService;
import com.glxp.api.admin.util.FilterUdiUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class InvStockPrintServiceImpl implements InvStockPrintService {

    @Resource
    InvStockPrintDao stockPrintDao;

    @Override
    public List<StockPrintEntity> filterStockPrint(FilterStockprintRequest filterStockprintRequest) {
        if (filterStockprintRequest == null) {
            return Collections.emptyList();
        }
        int offset = (filterStockprintRequest.getPage() - 1) * filterStockprintRequest.getLimit();
        PageHelper.offsetPage(offset, filterStockprintRequest.getLimit());
        List<StockPrintEntity> data = stockPrintDao.filterStockPrint(filterStockprintRequest);
        return data;
    }

    @Override
    public StockPrintEntity findByNameCode(String nameCode) {
        String prefix = FilterUdiUtils.getDiStr(nameCode);
        return stockPrintDao.findByNameCode(prefix);
    }

    @Override
    public StockPrintEntity findByRlId(FilterStockprintRequest udiRlIdFk) {
        return stockPrintDao.findByRlId(udiRlIdFk);
    }

    @Override
    public boolean insertStockPrint(StockPrintEntity stockPrintEntity) {
        return stockPrintDao.insertStockPrint(stockPrintEntity);
    }

    @Override
    public boolean insertStockPrints(List<StockPrintEntity> stockPrintEntities) {
        return stockPrintDao.insertStockPrints(stockPrintEntities);
    }

    @Override
    public boolean updateStockPrint(StockPrintEntity stockPrintEntity) {
        return stockPrintDao.updateStockPrint(stockPrintEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return stockPrintDao.deleteById(id);
    }

    @Override
    public boolean deleteByGenKey(String genKey) {
        return stockPrintDao.deleteByGenKey(genKey);
    }

    @Override
    public boolean updatePrintStatus(List<String> ids) {
        return stockPrintDao.updatePrintStatus(ids);
    }
}
