package com.glxp.api.admin.service.thrsys.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.thrsys.ThrCorpExportLogDao;
import com.glxp.api.admin.entity.thrsys.ThrCorpExportLogEntity;
import com.glxp.api.admin.entity.thrsys.ThrCorpImportLogEntity;
import com.glxp.api.admin.req.basic.FilterUdiEpLogRequest;
import com.glxp.api.admin.req.basic.FilterUdiIpLogRequest;
import com.glxp.api.admin.service.thrsys.ThrCorpExportLogService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class ThrCorpExportLogServiceImpl implements ThrCorpExportLogService {
    @Resource
    ThrCorpExportLogDao thrCorpExportLogDao;

    @Override
    public ThrCorpExportLogEntity selectByGenKey(String genKey) {
        FilterUdiEpLogRequest filterUdiEpLogRequest = new FilterUdiEpLogRequest();
        filterUdiEpLogRequest.setGenKey(genKey);
        List<ThrCorpExportLogEntity> data = thrCorpExportLogDao.filterThrCorpExportLog(filterUdiEpLogRequest);
        if (data != null && data.size() > 0) {
            return data.get(0);
        }
        return null;
    }

    @Override
    public List<ThrCorpExportLogEntity> filterThrCorpExportLog(FilterUdiEpLogRequest filterUdiEpLogRequest) {
        if (filterUdiEpLogRequest == null) {
            return Collections.emptyList();
        }
        if (filterUdiEpLogRequest.getPage() != null) {
            int offset = (filterUdiEpLogRequest.getPage() - 1) * filterUdiEpLogRequest.getLimit();
            PageHelper.offsetPage(offset, filterUdiEpLogRequest.getLimit());
        }
        List<ThrCorpExportLogEntity> data = thrCorpExportLogDao.filterThrCorpExportLog(filterUdiEpLogRequest);
        return data;
    }

    @Override
    public boolean insertThrCorpExportLog(ThrCorpExportLogEntity thrCorpExportLogEntity) {
        return thrCorpExportLogDao.insertThrCorpExportLog(thrCorpExportLogEntity);
    }

    @Override
    public boolean updateThrCorpExportLog(ThrCorpExportLogEntity thrCorpExportLogEntity) {
        return thrCorpExportLogDao.updateThrCorpExportLog(thrCorpExportLogEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return thrCorpExportLogDao.deleteById(id);
    }
}
