package com.glxp.api.admin.service.thrsys.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.thrsys.ThrCorpImportDetailDao;
import com.glxp.api.admin.entity.thrsys.ThrCorpImportDetailEntity;
import com.glxp.api.admin.req.basic.FilterUdiIpLogRequest;
import com.glxp.api.admin.service.thrsys.ThrCorpImportDetailService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class ThrCorpImportDetailServiceImpl implements ThrCorpImportDetailService {

    @Resource
    ThrCorpImportDetailDao thrCorpImportDetailDao;

    @Override
    public List<ThrCorpImportDetailEntity> filterCorpDetailImport(FilterUdiIpLogRequest filterUdiIpLogRequest) {
        if (filterUdiIpLogRequest == null) {
            return Collections.emptyList();
        }
        if (filterUdiIpLogRequest.getPage() != null) {
            int offset = (filterUdiIpLogRequest.getPage() - 1) * filterUdiIpLogRequest.getLimit();
            PageHelper.offsetPage(offset, filterUdiIpLogRequest.getLimit());
        }
        List<ThrCorpImportDetailEntity> data = thrCorpImportDetailDao.filterCorpDetailImport(filterUdiIpLogRequest);
        return data;
    }

    @Override
    public boolean insertCorpDetailImport(ThrCorpImportDetailEntity thrCorpImportDetailEntity) {
        return thrCorpImportDetailDao.insertCorpDetailImport(thrCorpImportDetailEntity);
    }

    @Override
    public boolean updateCorpDetailImport(ThrCorpImportDetailEntity thrCorpImportDetailEntity) {
        return thrCorpImportDetailDao.updateCorpDetailImport(thrCorpImportDetailEntity);
    }

    @Override
    public boolean insertCorpDetailImports(List<ThrCorpImportDetailEntity> thrCorpImportDetailEntities) {
        return thrCorpImportDetailDao.insertCorpDetailImports(thrCorpImportDetailEntities);
    }

    @Override
    public boolean deleteById(String id) {
        return thrCorpImportDetailDao.deleteById(id);
    }

    @Override
    public boolean deleteByGenkey(String genKey) {
        return thrCorpImportDetailDao.deleteByGenkey(genKey);
    }
}
