package com.glxp.api.admin.service.thrsys.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.thrsys.ThrCorpImportLogDao;
import com.glxp.api.admin.entity.thrsys.ThrCorpImportLogEntity;
import com.glxp.api.admin.req.basic.FilterUdiIpLogRequest;
import com.glxp.api.admin.service.thrsys.ThrCorpImportLogService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class ThrCorpImportLogServiceImpl implements ThrCorpImportLogService {
    @Resource
    ThrCorpImportLogDao thrCorpImportLogDao;

    @Override
    public ThrCorpImportLogEntity selectByGenKey(String genKey) {
        FilterUdiIpLogRequest filterUdiIpLogRequest = new FilterUdiIpLogRequest();
        filterUdiIpLogRequest.setGenKey(genKey);
        List<ThrCorpImportLogEntity> data = thrCorpImportLogDao.filterImportLog(filterUdiIpLogRequest);
        if (data != null && data.size() > 0) {
            return data.get(0);
        }
        return null;
    }

    @Override
    public List<ThrCorpImportLogEntity> filterImportLog(FilterUdiIpLogRequest filterInCodeLogRequest) {
        if (filterInCodeLogRequest == null) {
            return Collections.emptyList();
        }
        if (filterInCodeLogRequest.getPage() != null) {
            int offset = (filterInCodeLogRequest.getPage() - 1) * filterInCodeLogRequest.getLimit();
            PageHelper.offsetPage(offset, filterInCodeLogRequest.getLimit());
        }
        List<ThrCorpImportLogEntity> data = thrCorpImportLogDao.filterImportLog(filterInCodeLogRequest);
        return data;

    }

    @Override
    public boolean insertImportLog(ThrCorpImportLogEntity thrCorpImportLogEntity) {
        return thrCorpImportLogDao.insertImportLog(thrCorpImportLogEntity);
    }

    @Override
    public boolean updateImportLog(ThrCorpImportLogEntity thrCorpImportLogEntity) {
        return thrCorpImportLogDao.updateImportLog(thrCorpImportLogEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return thrCorpImportLogDao.deleteById(id);
    }
}
