package com.glxp.api.admin.service.thrsys.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.thrsys.ThrCorpDao;
import com.glxp.api.admin.entity.thrsys.ThrCorpEntity;
import com.glxp.api.admin.req.thrsys.FilterThrCorpRequest;
import com.glxp.api.admin.service.thrsys.ThrCorpService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class ThrCorpServiceImpl implements ThrCorpService {

    @Resource
    private ThrCorpDao thrCorpDao;

    @Override
    public List<ThrCorpEntity> filterThrCorps(FilterThrCorpRequest filterThrCorpRequest) {
        if (filterThrCorpRequest == null) {
            return Collections.emptyList();
        }
        if (filterThrCorpRequest.getPage() != null) {
            int offset = (filterThrCorpRequest.getPage() - 1) * filterThrCorpRequest.getLimit();
            PageHelper.offsetPage(offset, filterThrCorpRequest.getLimit());
        }
        List<ThrCorpEntity> data = thrCorpDao.filterThrCorps(filterThrCorpRequest);
        return data;
    }

    @Override
    public boolean insertThrCorps(ThrCorpEntity thrCorpEntity) {
        return thrCorpDao.insertThrCorps(thrCorpEntity);
    }

    @Override
    public boolean insertThrCorpss(List<ThrCorpEntity> thrCorpEntitys) {
        return thrCorpDao.insertThrCorpss(thrCorpEntitys);
    }

    @Override
    public boolean updateThrCorps(ThrCorpEntity thrCorpEntity) {
        return thrCorpDao.updateThrCorps(thrCorpEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return thrCorpDao.deleteById(id);
    }

    @Override
    public boolean deleteAll() {
        return thrCorpDao.deleteAll();
    }
}
