package com.glxp.api.admin.service.thrsys.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.thrsys.ThrInvProductsDetailDao;
import com.glxp.api.admin.entity.thrsys.ThrCorpImportDetailEntity;
import com.glxp.api.admin.entity.thrsys.ThrInvProductsImportDetailEntity;
import com.glxp.api.admin.req.basic.FilterUdiIpLogRequest;
import com.glxp.api.admin.service.thrsys.ThrInvProductsDetailService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class ThrInvProductsDetailServiceImpl implements ThrInvProductsDetailService {

    @Resource
    ThrInvProductsDetailDao thrInvProductsDetailDao;

    @Override
    public List<ThrInvProductsImportDetailEntity> filterInvProductsDetailImport(FilterUdiIpLogRequest filterUdiIpLogRequest) {
        if (filterUdiIpLogRequest == null) {
            return Collections.emptyList();
        }
        if (filterUdiIpLogRequest.getPage() != null) {
            int offset = (filterUdiIpLogRequest.getPage() - 1) * filterUdiIpLogRequest.getLimit();
            PageHelper.offsetPage(offset, filterUdiIpLogRequest.getLimit());
        }
        List<ThrInvProductsImportDetailEntity> data = thrInvProductsDetailDao.filterInvProductsDetailImport(filterUdiIpLogRequest);
        return data;
    }

    @Override
    public boolean insertInvProductsDetailImport(ThrInvProductsImportDetailEntity thrInvProductsImportDetailEntity) {
        return thrInvProductsDetailDao.insertInvProductsDetailImport(thrInvProductsImportDetailEntity);
    }

    @Override
    public boolean updateInvProductsDetailImport(ThrInvProductsImportDetailEntity thrInvProductsImportDetailEntity) {
        return thrInvProductsDetailDao.updateInvProductsDetailImport(thrInvProductsImportDetailEntity);
    }

    @Override
    public boolean insertInvProductsDetailImports(List<ThrInvProductsImportDetailEntity> thrInvProductsImportDetailEntities) {
        return thrInvProductsDetailDao.insertInvProductsDetailImports(thrInvProductsImportDetailEntities);
    }

    @Override
    public boolean deleteById(String id) {
        return thrInvProductsDetailDao.deleteById(id);
    }

    @Override
    public boolean deleteByGenkey(String genKey) {
        return thrInvProductsDetailDao.deleteByGenkey(genKey);
    }
}
