package com.glxp.api.admin.service.thrsys.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.thrsys.ThrInvProductsExportLogDao;
import com.glxp.api.admin.entity.thrsys.ThrInvProductsExportLogEntity;
import com.glxp.api.admin.req.basic.FilterUdiEpLogRequest;
import com.glxp.api.admin.service.thrsys.ThrInvProductsExportLogService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class ThrInvProductsExportLogServiceImpl implements ThrInvProductsExportLogService {

    @Resource
    ThrInvProductsExportLogDao thrInvProductsExportLogDao;

    @Override
    public ThrInvProductsExportLogEntity selectByGenKey(String genKey) {
        FilterUdiEpLogRequest filterUdiEpLogRequest = new FilterUdiEpLogRequest();
        filterUdiEpLogRequest.setGenKey(genKey);
        List<ThrInvProductsExportLogEntity> thrInvProductsExportLogEntities = thrInvProductsExportLogDao.filterThrInvProductsExportLog(filterUdiEpLogRequest);
        if (thrInvProductsExportLogEntities != null && thrInvProductsExportLogEntities.size() > 0) {
            return thrInvProductsExportLogEntities.get(0);
        }
        return null;
    }

    @Override
    public List<ThrInvProductsExportLogEntity> filterThrInvProductsExportLog(FilterUdiEpLogRequest filterUdiEpLogRequest) {
        if (filterUdiEpLogRequest == null) {
            return Collections.emptyList();
        }
        if (filterUdiEpLogRequest.getPage() != null) {
            int offset = (filterUdiEpLogRequest.getPage() - 1) * filterUdiEpLogRequest.getLimit();
            PageHelper.offsetPage(offset, filterUdiEpLogRequest.getLimit());
        }
        List<ThrInvProductsExportLogEntity> data = thrInvProductsExportLogDao.filterThrInvProductsExportLog(filterUdiEpLogRequest);
        return data;
    }

    @Override
    public boolean insertThrInvProductsExportLog(ThrInvProductsExportLogEntity thrInvProductsExportLogEntity) {
        return thrInvProductsExportLogDao.insertThrInvProductsExportLog(thrInvProductsExportLogEntity);
    }

    @Override
    public boolean updateThrInvProductsExportLog(ThrInvProductsExportLogEntity thrInvProductsExportLogEntity) {
        return thrInvProductsExportLogDao.updateThrInvProductsExportLog(thrInvProductsExportLogEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return thrInvProductsExportLogDao.deleteById(id);
    }
}
