package com.glxp.api.admin.service.thrsys.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.thrsys.ThrInvProductsImportLogDao;
import com.glxp.api.admin.entity.thrsys.ThrInvProductsImportLogEntity;
import com.glxp.api.admin.req.basic.FilterUdiIpLogRequest;
import com.glxp.api.admin.service.thrsys.ThrInvProductsImportLogService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;
@Service
public class ThrInvProductsImportLogServiceImpl implements ThrInvProductsImportLogService
{

    @Resource
    ThrInvProductsImportLogDao thrInvProductsImportLogDao;

    @Override
    public List<ThrInvProductsImportLogEntity> filterImportLog(FilterUdiIpLogRequest filterInCodeLogRequest) {
        if (filterInCodeLogRequest == null) {
            return Collections.emptyList();
        }
        if (filterInCodeLogRequest.getPage() != null) {
            int offset = (filterInCodeLogRequest.getPage() - 1) * filterInCodeLogRequest.getLimit();
            PageHelper.offsetPage(offset, filterInCodeLogRequest.getLimit());
        }
        List<ThrInvProductsImportLogEntity> data = thrInvProductsImportLogDao.filterImportLog(filterInCodeLogRequest);
        return data;
    }

    @Override
    public boolean insertImportLog(ThrInvProductsImportLogEntity thrInvProductsImportLogEntity) {
        return thrInvProductsImportLogDao.insertImportLog(thrInvProductsImportLogEntity);
    }

    @Override
    public boolean updateImportLog(ThrInvProductsImportLogEntity thrInvProductsImportLogEntity) {
        return thrInvProductsImportLogDao.updateImportLog(thrInvProductsImportLogEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return thrInvProductsImportLogDao.deleteById(id);
    }

    @Override
    public ThrInvProductsImportLogEntity selectByGenKey(String genKey) {
        FilterUdiIpLogRequest filterUdiIpLogRequest = new FilterUdiIpLogRequest();
        filterUdiIpLogRequest.setGenKey(genKey);
        List<ThrInvProductsImportLogEntity> data = thrInvProductsImportLogDao.filterImportLog(filterUdiIpLogRequest);
        if (data != null && data.size() > 0) {
            return data.get(0);
        }
        return null;
    }
}
