package com.glxp.api.admin.service.thrsys.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.thrsys.ThrCorpDao;
import com.glxp.api.admin.dao.thrsys.ThrInvProductsDao;
import com.glxp.api.admin.entity.thrsys.ThrCorpEntity;
import com.glxp.api.admin.entity.thrsys.ThrInvProductsEntity;
import com.glxp.api.admin.req.thrsys.FilterThrInvProductsRequest;
import com.glxp.api.admin.service.thrsys.ThrInvProductsService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class ThrInvProductsServiceImpl implements ThrInvProductsService {

    @Resource
    private ThrInvProductsDao thrInvProductsDao;

    @Override
    public List<ThrInvProductsEntity> filterThrInvProductss(FilterThrInvProductsRequest filterThrInvProductsRequest) {
        if (filterThrInvProductsRequest == null) {
            return Collections.emptyList();
        }
        if (filterThrInvProductsRequest.getPage() != null) {
            int offset = (filterThrInvProductsRequest.getPage() - 1) * filterThrInvProductsRequest.getLimit();
            PageHelper.offsetPage(offset, filterThrInvProductsRequest.getLimit());
        }
        List<ThrInvProductsEntity> data = thrInvProductsDao.filterThrInvProductss(filterThrInvProductsRequest);
        return data;
    }

    @Override
    public ThrInvProductsEntity selectById(String id) {
        return thrInvProductsDao.selectById(id);
    }

    @Override
    public boolean insertThrInvProduct(ThrInvProductsEntity thrInvProductsEntity) {
        return thrInvProductsDao.insertThrInvProduct(thrInvProductsEntity);
    }

    @Override
    public boolean insertThrInvProducts(List<ThrInvProductsEntity> thrInvProductsEntities) {
        return thrInvProductsDao.insertThrInvProducts(thrInvProductsEntities);
    }

    @Override
    public boolean updateThrInvProducts(ThrInvProductsEntity thrInvProductsEntity) {
        return thrInvProductsDao.updateThrInvProducts(thrInvProductsEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return thrInvProductsDao.deleteById(id);
    }

    @Override
    public boolean deleteAll() {
        return thrInvProductsDao.deleteAll();
    }
}
