package com.glxp.api.admin.service.thrsys.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.thrsys.ThrOrderDetailDao;
import com.glxp.api.admin.entity.thrsys.ThrInvProductsEntity;
import com.glxp.api.admin.entity.thrsys.ThrOrderDetailEntity;
import com.glxp.api.admin.req.thrsys.FilterThrOrderDetailRequest;
import com.glxp.api.admin.service.thrsys.ThrOrderDetailService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class ThrOrderDetailServiceImpl implements ThrOrderDetailService {

    @Resource
    ThrOrderDetailDao thrOrderDetailDao;

    @Override
    public List<ThrOrderDetailEntity> filterThrOrderDetailDetail(FilterThrOrderDetailRequest filterThrOrderDetailRequest) {
        if (filterThrOrderDetailRequest == null) {
            return Collections.emptyList();
        }
        if (filterThrOrderDetailRequest.getPage() != null) {
            int offset = (filterThrOrderDetailRequest.getPage() - 1) * filterThrOrderDetailRequest.getLimit();
            PageHelper.offsetPage(offset, filterThrOrderDetailRequest.getLimit());
        }
        List<ThrOrderDetailEntity> data = thrOrderDetailDao.filterThrOrderDetailDetail(filterThrOrderDetailRequest);
        return data;
    }

    @Override
    public boolean insertThrOrderDetail(ThrOrderDetailEntity thrOrderDetailEntity) {
        return thrOrderDetailDao.insertThrOrderDetail(thrOrderDetailEntity);
    }

    @Override
    public boolean insertThrOrderDetails(List<ThrOrderDetailEntity> thrOrderDetailEntities) {
        return thrOrderDetailDao.insertThrOrderDetails(thrOrderDetailEntities);
    }

    @Override
    public boolean updateThrOrderDetail(ThrOrderDetailEntity thrOrderDetailEntity) {
        return thrOrderDetailDao.updateThrOrderDetail(thrOrderDetailEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return thrOrderDetailDao.deleteById(id);
    }

    @Override
    public boolean deleteByOrderIdFk(String id) {
        return thrOrderDetailDao.deleteByOrderIdFk(id);
    }

    @Override
    public boolean deleteAll() {
        return thrOrderDetailDao.deleteAll();
    }
}
