package com.glxp.api.admin.service.thrsys.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.thrsys.ThrOrderExportLogDao;
import com.glxp.api.admin.entity.thrsys.ThrOrderExportLogEntity;
import com.glxp.api.admin.req.basic.FilterUdiEpLogRequest;
import com.glxp.api.admin.service.thrsys.ThrOrderExportLogService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class ThrOrderExportLogServiceImpl implements ThrOrderExportLogService {

    @Resource
    ThrOrderExportLogDao thrOrderExportLogDao;

    @Override
    public ThrOrderExportLogEntity selectByGenKey(String genKey) {
        FilterUdiEpLogRequest filterUdiEpLogRequest = new FilterUdiEpLogRequest();
        filterUdiEpLogRequest.setGenKey(genKey);
        List<ThrOrderExportLogEntity> thrOrderExportLogEntities = thrOrderExportLogDao.filterThrOrderExportLog(filterUdiEpLogRequest);
        if (thrOrderExportLogEntities != null) {
            return thrOrderExportLogEntities.get(0);
        }
        return null;
    }

    @Override
    public List<ThrOrderExportLogEntity> filterThrOrderExportLog(FilterUdiEpLogRequest filterUdiEpLogRequest) {
        if (filterUdiEpLogRequest == null) {
            return Collections.emptyList();
        }
        if (filterUdiEpLogRequest.getPage() != null) {
            int offset = (filterUdiEpLogRequest.getPage() - 1) * filterUdiEpLogRequest.getLimit();
            PageHelper.offsetPage(offset, filterUdiEpLogRequest.getLimit());
        }
        List<ThrOrderExportLogEntity> data = thrOrderExportLogDao.filterThrOrderExportLog(filterUdiEpLogRequest);
        return data;
    }

    @Override
    public boolean insertThrOrderExportLog(ThrOrderExportLogEntity thrOrderExportLogEntity) {
        return thrOrderExportLogDao.insertThrOrderExportLog(thrOrderExportLogEntity);
    }

    @Override
    public boolean updateThrOrderExportLog(ThrOrderExportLogEntity thrOrderExportLogEntity) {
        return thrOrderExportLogDao.updateThrOrderExportLog(thrOrderExportLogEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return thrOrderExportLogDao.deleteById(id);
    }
}
