package com.glxp.api.admin.service.thrsys.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.thrsys.ThrOrderImportDetailDao;
import com.glxp.api.admin.entity.thrsys.ThrOrderImportDetailEntity;
import com.glxp.api.admin.req.basic.FilterUdiIpLogRequest;
import com.glxp.api.admin.service.thrsys.ThrOrderImportDetailService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class ThrOrderImportDetailServiceImpl implements ThrOrderImportDetailService {

    @Resource
    ThrOrderImportDetailDao thrOrderImportDetailDao;

    @Override
    public List<ThrOrderImportDetailEntity> filterOrderImportDetail(FilterUdiIpLogRequest filterUdiIpLogRequest) {
        if (filterUdiIpLogRequest == null) {
            return Collections.emptyList();
        }
        if (filterUdiIpLogRequest.getPage() != null) {
            int offset = (filterUdiIpLogRequest.getPage() - 1) * filterUdiIpLogRequest.getLimit();
            PageHelper.offsetPage(offset, filterUdiIpLogRequest.getLimit());
        }
        List<ThrOrderImportDetailEntity> data = thrOrderImportDetailDao.filterOrderdDetailImport(filterUdiIpLogRequest);
        return data;
    }

    @Override
    public boolean insertOrderImportDetail(ThrOrderImportDetailEntity thrOrderImportDetailEntity) {
        return thrOrderImportDetailDao.insertOrderdDetailImport(thrOrderImportDetailEntity);
    }

    @Override
    public boolean updateOrderImportDetail(ThrOrderImportDetailEntity thrOrderImportDetailEntity) {
        return thrOrderImportDetailDao.updateOrderdDetailImport(thrOrderImportDetailEntity);
    }

    @Override
    public boolean insertOrderImportDetails(List<ThrOrderImportDetailEntity> thrOrderImportDetailEntities) {
        return thrOrderImportDetailDao.insertOrderdDetailImports(thrOrderImportDetailEntities);
    }

    @Override
    public boolean deleteById(String id) {
        return thrOrderImportDetailDao.deleteById(id);
    }

    @Override
    public boolean deleteByGenkey(String genKey) {
        return thrOrderImportDetailDao.deleteByGenkey(genKey);
    }
}
