package com.glxp.api.admin.service.thrsys.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.thrsys.ThrOrderImportLogDao;
import com.glxp.api.admin.entity.basic.CorpImportLogEntity;
import com.glxp.api.admin.entity.thrsys.ThrOrderImportLogEntity;
import com.glxp.api.admin.req.basic.FilterUdiIpLogRequest;
import com.glxp.api.admin.service.thrsys.ThrOrderImportLogService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;


@Service
public class ThrOrderImportLogServiceImpl implements ThrOrderImportLogService {
    @Resource
    ThrOrderImportLogDao thrOrderImportLogDao;

    @Override
    public ThrOrderImportLogEntity selectByGenKey(String genKey) {
        FilterUdiIpLogRequest filterUdiIpLogRequest = new FilterUdiIpLogRequest();
        filterUdiIpLogRequest.setGenKey(genKey);
        List<ThrOrderImportLogEntity> data = thrOrderImportLogDao.filterImportLog(filterUdiIpLogRequest);
        if (data != null && data.size() > 0) {
            return data.get(0);
        }
        return null;
    }

    @Override
    public List<ThrOrderImportLogEntity> filterImportLog(FilterUdiIpLogRequest filterInCodeLogRequest) {
        if (filterInCodeLogRequest == null) {
            return Collections.emptyList();
        }
        if (filterInCodeLogRequest.getPage() != null) {
            int offset = (filterInCodeLogRequest.getPage() - 1) * filterInCodeLogRequest.getLimit();
            PageHelper.offsetPage(offset, filterInCodeLogRequest.getLimit());
        }
        List<ThrOrderImportLogEntity> data = thrOrderImportLogDao.filterImportLog(filterInCodeLogRequest);
        return data;

    }

    @Override
    public boolean insertImportLog(ThrOrderImportLogEntity thrOrderImportLogEntity) {
        return thrOrderImportLogDao.insertImportLog(thrOrderImportLogEntity);
    }

    @Override
    public boolean updateImportLog(ThrOrderImportLogEntity thrOrderImportLogEntity) {
        return thrOrderImportLogDao.updateImportLog(thrOrderImportLogEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return thrOrderImportLogDao.deleteById(id);
    }
}
