package com.glxp.api.admin.service.thrsys.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.thrsys.ThrProductsImportDetailDao;
import com.glxp.api.admin.entity.thrsys.ThrProductsImportDetailEntity;
import com.glxp.api.admin.req.basic.FilterUdiIpLogRequest;
import com.glxp.api.admin.service.thrsys.ThrProductsImportDetailService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class ThrProductsImportDetailServiceImpl implements ThrProductsImportDetailService {

    @Resource
    ThrProductsImportDetailDao thrProductsImportDetailDao;

    @Override
    public List<ThrProductsImportDetailEntity> filterProductsDetailImport(FilterUdiIpLogRequest filterUdiIpLogRequest) {
        if (filterUdiIpLogRequest == null) {
            return Collections.emptyList();
        }
        if (filterUdiIpLogRequest.getPage() != null) {
            int offset = (filterUdiIpLogRequest.getPage() - 1) * filterUdiIpLogRequest.getLimit();
            PageHelper.offsetPage(offset, filterUdiIpLogRequest.getLimit());
        }
        List<ThrProductsImportDetailEntity> data = thrProductsImportDetailDao.filterProductsDetailImport(filterUdiIpLogRequest);
        return data;
    }

    @Override
    public boolean insertProductsDetailImport(ThrProductsImportDetailEntity thrOrderImportDetailEntity) {
        return thrProductsImportDetailDao.insertProductsDetailImport(thrOrderImportDetailEntity);
    }

    @Override
    public boolean updateProductsDetailImport(ThrProductsImportDetailEntity thrOrderImportDetailEntity) {
        return thrProductsImportDetailDao.updateProductsDetailImport(thrOrderImportDetailEntity);
    }

    @Override
    public boolean insertProductsDetailImports(List<ThrProductsImportDetailEntity> thrOrderImportDetailEntities) {
        return thrProductsImportDetailDao.insertProductsDetailImports(thrOrderImportDetailEntities);
    }

    @Override
    public boolean deleteById(String id) {
        return thrProductsImportDetailDao.deleteById(id);
    }

    @Override
    public boolean deleteByGenkey(String genKey) {
        return thrProductsImportDetailDao.deleteByGenkey(genKey);
    }
}
