package com.glxp.api.admin.service.thrsys.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.api.admin.dao.thrsys.ThrProductsImportLogDao;
import com.glxp.api.admin.entity.thrsys.ThrProductsImportLogEntity;
import com.glxp.api.admin.req.basic.FilterUdiIpLogRequest;
import com.glxp.api.admin.service.thrsys.ThrProductsImportLogService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class ThrProductsImportLogServiceImpl implements ThrProductsImportLogService {
    @Resource
    ThrProductsImportLogDao thrProductsImportLogDao;

    @Override
    public List<ThrProductsImportLogEntity> filterImportLog(FilterUdiIpLogRequest filterInCodeLogRequest) {
        if (filterInCodeLogRequest == null) {
            return Collections.emptyList();
        }
        if (filterInCodeLogRequest.getPage() != null) {
            int offset = (filterInCodeLogRequest.getPage() - 1) * filterInCodeLogRequest.getLimit();
            PageHelper.offsetPage(offset, filterInCodeLogRequest.getLimit());
        }
        List<ThrProductsImportLogEntity> data = thrProductsImportLogDao.filterImportLog(filterInCodeLogRequest);
        return data;
    }

    @Override
    public boolean insertImportLog(ThrProductsImportLogEntity thrProductsImportLogEntity) {
        return thrProductsImportLogDao.insertImportLog(thrProductsImportLogEntity);
    }

    @Override
    public boolean updateImportLog(ThrProductsImportLogEntity thrProductsImportLogEntity) {
        return thrProductsImportLogDao.updateImportLog(thrProductsImportLogEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return thrProductsImportLogDao.deleteById(id);
    }

    @Override
    public ThrProductsImportLogEntity selectByGenKey(String genKey) {
        FilterUdiIpLogRequest filterUdiIpLogRequest = new FilterUdiIpLogRequest();
        filterUdiIpLogRequest.setGenKey(genKey);
        List<ThrProductsImportLogEntity> data = thrProductsImportLogDao.filterImportLog(filterUdiIpLogRequest);
        if (data != null && data.size() > 0) {
            return data.get(0);
        }
        return null;
    }
}
