package com.glxp.api.admin.thread;

import com.glxp.api.admin.constant.ConstantStatus;
import com.glxp.api.admin.entity.basic.UdiInfoEntity;
import com.glxp.api.admin.entity.basic.UdiRelevanceEntity;
import com.glxp.api.admin.entity.info.SystemParamConfigEntity;
import com.glxp.api.admin.entity.thrsys.ThrProductsEntity;
import com.glxp.api.admin.httpclient.ErpBasicClient;
import com.glxp.api.admin.httpclient.ErpInvClient;
import com.glxp.api.admin.req.basic.FilterErpGoodsRequest;
import com.glxp.api.admin.req.inventory.ErpOnhandRequest;
import com.glxp.api.admin.req.thrsys.FilterThrProductsRequest;
import com.glxp.api.admin.res.PageSimpleResponse;
import com.glxp.api.admin.res.basic.ErpProductsResponse;
import com.glxp.api.admin.res.inventory.ErpInvProductResponse;
import com.glxp.api.admin.service.basic.UdiInfoService;
import com.glxp.api.admin.service.basic.UdiRelevanceService;
import com.glxp.api.admin.service.info.SystemParamConfigService;
import com.glxp.api.admin.service.thrsys.ThrProductsService;
import com.glxp.api.admin.util.CustomUtil;
import com.glxp.api.admin.util.DateUtil;
import com.glxp.api.common.res.BaseResponse;
import org.springframework.beans.BeanUtils;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@Service
public class BasicBackUpdateProductService {
    @Resource
    UdiRelevanceService udiRelevanceService;
    @Resource
    UdiInfoService udiInfoService;
    @Resource
    ThrProductsService thrProductsService;
    @Resource
    SystemParamConfigService systemParamConfigService;


    //定时或一键下载更新全部线上产品信息
    @Async
    public void addAllProducts(FilterErpGoodsRequest filterErpGoodsRequest, String productUrl, String onHandUrl, String thirdSysId, Boolean isEnable) {
        int page = 1;
        if (filterErpGoodsRequest == null) {
            filterErpGoodsRequest = new FilterErpGoodsRequest();
        }
        filterErpGoodsRequest.setPage(1);
        filterErpGoodsRequest.setLimit(100);
        while (page != -1) {
            page = getAllProducts(filterErpGoodsRequest, productUrl, onHandUrl, thirdSysId, isEnable);
        }
    }

    //定时或一键下载更新全部线上产品信息
    public int getAllProducts(FilterErpGoodsRequest filterErpGoodsRequest, String productUrl, String
            onHandUrl, String thirdSysId, Boolean isEnable) {

        BaseResponse<PageSimpleResponse<ErpProductsResponse>> erpProducts = new ErpBasicClient().getErpProducts(filterErpGoodsRequest, productUrl);
        List<ErpProductsResponse> invmandocResponses = erpProducts.getData().getList();
        SystemParamConfigEntity isUpdate = systemParamConfigService.selectByParamKey("erp_updateErpData_type");
        if (isEnable == null || isEnable == false) {
            isUpdate.setParamValue("1");
        }
        Map<String, ErpProductsResponse> erpProductsMap = new HashMap<>();
        if (invmandocResponses != null && invmandocResponses.size() > 0) {
            List<String> inventoryCodes = new ArrayList<>();
//            if (filterErpGoodsRequest.getCode() != null) {
//                inventoryCodes.add(filterErpGoodsRequest.getCode());
//                erpProductsMap.put(filterErpGoodsRequest.getCode(), invmandocResponses.get(0));
//            } else {
            for (ErpProductsResponse invmandocResponse : invmandocResponses) {
                UdiRelevanceEntity udiRelevanceEntity = udiRelevanceService.selectByThirdId(invmandocResponse.getCode(), thirdSysId);
                if (udiRelevanceEntity == null) {
                    inventoryCodes.add(invmandocResponse.getCode());
                    erpProductsMap.put(invmandocResponse.getCode(), invmandocResponse);
                    if (isUpdate.getParamValue().equals("1")) {//不根据库存信息过滤
                        UdiInfoEntity udiInfoEntity = new UdiInfoEntity();
                        udiInfoEntity.setNameCode(invmandocResponse.getCode());
                        udiInfoEntity.setCpmctymc(invmandocResponse.getName());
                        udiInfoEntity.setGgxh(invmandocResponse.getSpec());
                        udiInfoEntity.setUuid(CustomUtil.getUUId());
                        udiInfoEntity.setProductType(ConstantStatus.PRODUCT_TYPE_THIRD);
                        udiInfoEntity.setDiType(ConstantStatus.DI_TYPE_MAIN);

                        udiInfoEntity.setManufactory(invmandocResponses.get(0).getManufactory());
                        udiInfoEntity.setYlqxzcrbarmc(invmandocResponses.get(0).getManufactory());
                        udiInfoEntity.setZczbhhzbapzbh(invmandocResponses.get(0).getRegisterNo());
                        udiInfoService.insertUdiInfo(udiInfoEntity);
                        UdiRelevanceEntity udiRelevanceEntity1 = new UdiRelevanceEntity();
                        udiRelevanceEntity1.setUuid(udiInfoEntity.getUuid());
                        if ("thirdId".equals(thirdSysId)) {
                            udiRelevanceEntity1.setThirdId(invmandocResponse.getCode());
                            udiRelevanceEntity1.setThirdName(invmandocResponse.getName());
                        } else if ("thirdId1".equals(thirdSysId)) {
                            udiRelevanceEntity1.setThirdId1(invmandocResponse.getCode());
                            udiRelevanceEntity1.setThirdName1(invmandocResponse.getName());
                        } else if ("thirdId2".equals(thirdSysId)) {
                            udiRelevanceEntity1.setThirdId4(invmandocResponse.getCode());
                            udiRelevanceEntity1.setThirdName4(invmandocResponse.getName());
                        } else if ("thirdId3".equals(thirdSysId)) {
                            udiRelevanceEntity1.setThirdId3(invmandocResponse.getCode());
                            udiRelevanceEntity1.setThirdName3(invmandocResponse.getName());
                        } else if ("thirdId4".equals(thirdSysId)) {
                            udiRelevanceEntity1.setThirdId4(invmandocResponse.getCode());
                            udiRelevanceEntity1.setThirdName4(invmandocResponse.getName());
                        }
                        udiRelevanceEntity1.setThirdId(invmandocResponse.getCode());
                        udiRelevanceEntity1.setThirdName(invmandocResponse.getName());
                        udiRelevanceEntity1.setUpdateTime(DateUtil.getDateTime());
                        udiRelevanceService.insertUdiRelevance(udiRelevanceEntity1);
                    }
                }

//                }
            }

            //若需要对照库存信息
            if (!isUpdate.getParamValue().equals("1")) {
                if (inventoryCodes.size() > 0) {
                    ErpOnhandRequest erpOnhandRequest = new ErpOnhandRequest();
                    erpOnhandRequest.setInventoryCodes(inventoryCodes);
                    List<ErpInvProductResponse> erpOnHandResponses = new ErpInvClient().getInvPrdoduct(erpOnhandRequest, onHandUrl);
                    if (erpOnHandResponses != null) {
                        Map<String, List<ErpInvProductResponse>> map = erpOnHandResponses.stream().collect(Collectors.groupingBy(ErpInvProductResponse::getCode));
                        for (List<ErpInvProductResponse> onHandResponses : map.values()) {
                            if (onHandResponses != null && onHandResponses.size() > 0) {
                                ErpInvProductResponse onhandQueryResponse = onHandResponses.get(0);
                                if (isUpdate.getParamValue().equals("2")) {
                                    addRl(onhandQueryResponse, thirdSysId, erpProductsMap);
                                } else if (isUpdate.getParamValue().equals("3")) {
                                    if (onhandQueryResponse.getCount() != null && onhandQueryResponse.getCount() > 0) {
                                        addRl(onhandQueryResponse, thirdSysId, erpProductsMap);
                                    }
                                } else if (isUpdate.getParamValue().equals("4")) {
                                    if (onhandQueryResponse.getCount() == null || onhandQueryResponse.getCount() <= 0) {
                                        addRl(onhandQueryResponse, thirdSysId, erpProductsMap);
                                    }
                                }

                            }
                        }
                    }
                }
            }

            filterErpGoodsRequest.setPage(filterErpGoodsRequest.getPage() + 1);
            if (filterErpGoodsRequest.getPage() * filterErpGoodsRequest.getLimit() < erpProducts.getData().getTotal()) {
                return filterErpGoodsRequest.getPage();
            }
        } else {
            return -1;
        }

        return -1;
    }


    //定时或一键下载更新本地所有产品信息
    @Async
    public void loadLocal(FilterErpGoodsRequest filterErpGoodsRequest, String thirdSysId, String onHandUrl, Boolean isEnable) {
        if (filterErpGoodsRequest == null) {
            filterErpGoodsRequest = new FilterErpGoodsRequest();
        }
        FilterThrProductsRequest filterThrInvProductsRequest = new FilterThrProductsRequest();
        BeanUtils.copyProperties(filterErpGoodsRequest, filterThrInvProductsRequest);
        filterThrInvProductsRequest.setPage(null);
        List<ThrProductsEntity> thrProductsEntities = thrProductsService.filterThrProductsRequest(filterThrInvProductsRequest);

        SystemParamConfigEntity isUpdate = systemParamConfigService.selectByParamKey("erp_updateErpData_type");
        if (isEnable == null || isEnable == false) {
            isUpdate.setParamValue("1");
        }

        if (thrProductsEntities != null && thrProductsEntities.size() > 0) {
            for (ThrProductsEntity thrProductsEntity : thrProductsEntities) {
                UdiRelevanceEntity udiRelevanceEntity = udiRelevanceService.selectByThirdId(thrProductsEntity.getCode(), thirdSysId);
                if (udiRelevanceEntity == null) {
                    if (isUpdate.getParamValue().equals("1")) {

                        UdiInfoEntity udiInfoEntity = new UdiInfoEntity();
                        udiInfoEntity.setNameCode(thrProductsEntity.getCode());
                        udiInfoEntity.setCpmctymc(thrProductsEntity.getName());
                        udiInfoEntity.setGgxh(thrProductsEntity.getSpec());
                        udiInfoEntity.setUuid(CustomUtil.getUUId());
                        udiInfoEntity.setProductType(ConstantStatus.PRODUCT_TYPE_THIRD);
                        udiInfoEntity.setDiType(ConstantStatus.DI_TYPE_MAIN);
                        udiInfoEntity.setManufactory(thrProductsEntity.getManufactory());
                        udiInfoEntity.setYlqxzcrbarmc(thrProductsEntity.getManufactory());
                        udiInfoEntity.setZczbhhzbapzbh(thrProductsEntity.getRegisterNo());
                        udiInfoService.insertUdiInfo(udiInfoEntity);
                        UdiRelevanceEntity udiRelevanceEntity1 = new UdiRelevanceEntity();
                        udiRelevanceEntity1.setUuid(udiInfoEntity.getUuid());


                        if ("thirdId".equals(thirdSysId)) {
                            udiRelevanceEntity1.setThirdId(thrProductsEntity.getCode());
                            udiRelevanceEntity1.setThirdName(thrProductsEntity.getName());
                        } else if ("thirdId1".equals(thirdSysId)) {
                            udiRelevanceEntity1.setThirdId1(thrProductsEntity.getCode());
                            udiRelevanceEntity1.setThirdName1(thrProductsEntity.getName());
                        } else if ("thirdId2".equals(thirdSysId)) {
                            udiRelevanceEntity1.setThirdId4(thrProductsEntity.getCode());
                            udiRelevanceEntity1.setThirdName4(thrProductsEntity.getName());
                        } else if ("thirdId3".equals(thirdSysId)) {
                            udiRelevanceEntity1.setThirdId3(thrProductsEntity.getCode());
                            udiRelevanceEntity1.setThirdName3(thrProductsEntity.getName());
                        } else if ("thirdId4".equals(thirdSysId)) {
                            udiRelevanceEntity1.setThirdId4(thrProductsEntity.getCode());
                            udiRelevanceEntity1.setThirdName4(thrProductsEntity.getName());
                        }

                        udiRelevanceEntity1.setThirdId(thrProductsEntity.getCode());
                        udiRelevanceEntity1.setThirdName(thrProductsEntity.getName());
                        udiRelevanceEntity1.setUpdateTime(DateUtil.getDateTime());
                        udiRelevanceService.insertUdiRelevance(udiRelevanceEntity1);
                    } else {
                        ErpOnhandRequest erpOnhandRequest = new ErpOnhandRequest();
                        erpOnhandRequest.setInventoryCode(thrProductsEntity.getCode());
                        List<ErpInvProductResponse> erpOnHandResponses = new ErpInvClient().getInvPrdoduct(erpOnhandRequest, onHandUrl);
                        if (erpOnHandResponses != null && erpOnHandResponses.size() > 0) {
                            ErpInvProductResponse onhandQueryResponse = erpOnHandResponses.get(0);
                            if (isUpdate.getParamValue().equals("2")) {
                                addRl(onhandQueryResponse, thirdSysId, thrProductsEntity);
                            } else if (isUpdate.getParamValue().equals("3")) {
                                if (onhandQueryResponse.getCount() != null && onhandQueryResponse.getCount() > 0) {
                                    addRl(onhandQueryResponse, thirdSysId, thrProductsEntity);
                                }
                            } else if (isUpdate.getParamValue().equals("4")) {
                                if (onhandQueryResponse.getCount() == null || onhandQueryResponse.getCount() <= 0) {
                                    addRl(onhandQueryResponse, thirdSysId, thrProductsEntity);
                                }
                            }
                        }
                    }
                }

            }
        }


    }


    public void addRl(ErpInvProductResponse onhandQueryResponse, String
            thirdSysId, Map<String, ErpProductsResponse> erpProductsMap) {
        UdiInfoEntity udiInfoEntity = new UdiInfoEntity();
        udiInfoEntity.setNameCode(onhandQueryResponse.getCode());
        udiInfoEntity.setCpmctymc(onhandQueryResponse.getName());
        udiInfoEntity.setGgxh(onhandQueryResponse.getSpec());
        udiInfoEntity.setUuid(CustomUtil.getUUId());
        udiInfoEntity.setProductType(ConstantStatus.PRODUCT_TYPE_THIRD);
        udiInfoEntity.setDiType(ConstantStatus.DI_TYPE_MAIN);
        udiInfoEntity.setManufactory(erpProductsMap.get(onhandQueryResponse.getCode()).getManufactory());
        udiInfoEntity.setYlqxzcrbarmc(erpProductsMap.get(onhandQueryResponse.getCode()).getManufactory());
        udiInfoEntity.setZczbhhzbapzbh(erpProductsMap.get(onhandQueryResponse.getCode()).getRegisterNo());
        udiInfoService.insertUdiInfo(udiInfoEntity);
        UdiRelevanceEntity udiRelevanceEntity1 = new UdiRelevanceEntity();
        udiRelevanceEntity1.setUuid(udiInfoEntity.getUuid());

        if ("thirdId".equals(thirdSysId)) {
            udiRelevanceEntity1.setThirdId(onhandQueryResponse.getCode());
            udiRelevanceEntity1.setThirdName(onhandQueryResponse.getName());
        } else if ("thirdId1".equals(thirdSysId)) {
            udiRelevanceEntity1.setThirdId1(onhandQueryResponse.getCode());
            udiRelevanceEntity1.setThirdName1(onhandQueryResponse.getName());
        } else if ("thirdId2".equals(thirdSysId)) {
            udiRelevanceEntity1.setThirdId4(onhandQueryResponse.getCode());
            udiRelevanceEntity1.setThirdName4(onhandQueryResponse.getName());
        } else if ("thirdId3".equals(thirdSysId)) {
            udiRelevanceEntity1.setThirdId3(onhandQueryResponse.getCode());
            udiRelevanceEntity1.setThirdName3(onhandQueryResponse.getName());
        } else if ("thirdId4".equals(thirdSysId)) {
            udiRelevanceEntity1.setThirdId4(onhandQueryResponse.getCode());
            udiRelevanceEntity1.setThirdName4(onhandQueryResponse.getName());
        }

        udiRelevanceEntity1.setThirdId(onhandQueryResponse.getCode());
        udiRelevanceEntity1.setThirdName(onhandQueryResponse.getName());
        udiRelevanceEntity1.setUpdateTime(DateUtil.getDateTime());
        udiRelevanceService.insertUdiRelevance(udiRelevanceEntity1);
    }

    public void addRl(ErpInvProductResponse onhandQueryResponse, String
            thirdSysId, ThrProductsEntity erpProductsResponse) {
        UdiInfoEntity udiInfoEntity = new UdiInfoEntity();
        udiInfoEntity.setNameCode(onhandQueryResponse.getCode());
        udiInfoEntity.setCpmctymc(onhandQueryResponse.getName());
        udiInfoEntity.setGgxh(onhandQueryResponse.getSpec());
        udiInfoEntity.setUuid(CustomUtil.getUUId());
        udiInfoEntity.setProductType(ConstantStatus.PRODUCT_TYPE_THIRD);
        udiInfoEntity.setDiType(ConstantStatus.DI_TYPE_MAIN);
        udiInfoEntity.setManufactory(erpProductsResponse.getManufactory());
        udiInfoEntity.setYlqxzcrbarmc(erpProductsResponse.getManufactory());
        udiInfoEntity.setZczbhhzbapzbh(erpProductsResponse.getRegisterNo());
        udiInfoService.insertUdiInfo(udiInfoEntity);
        UdiRelevanceEntity udiRelevanceEntity1 = new UdiRelevanceEntity();
        udiRelevanceEntity1.setUuid(udiInfoEntity.getUuid());

        if ("thirdId".equals(thirdSysId)) {
            udiRelevanceEntity1.setThirdId(onhandQueryResponse.getCode());
            udiRelevanceEntity1.setThirdName(onhandQueryResponse.getName());
        } else if ("thirdId1".equals(thirdSysId)) {
            udiRelevanceEntity1.setThirdId1(onhandQueryResponse.getCode());
            udiRelevanceEntity1.setThirdName1(onhandQueryResponse.getName());
        } else if ("thirdId2".equals(thirdSysId)) {
            udiRelevanceEntity1.setThirdId4(onhandQueryResponse.getCode());
            udiRelevanceEntity1.setThirdName4(onhandQueryResponse.getName());
        } else if ("thirdId3".equals(thirdSysId)) {
            udiRelevanceEntity1.setThirdId3(onhandQueryResponse.getCode());
            udiRelevanceEntity1.setThirdName3(onhandQueryResponse.getName());
        } else if ("thirdId4".equals(thirdSysId)) {
            udiRelevanceEntity1.setThirdId4(onhandQueryResponse.getCode());
            udiRelevanceEntity1.setThirdName4(onhandQueryResponse.getName());
        }

        udiRelevanceEntity1.setThirdId(onhandQueryResponse.getCode());
        udiRelevanceEntity1.setThirdName(onhandQueryResponse.getName());
        udiRelevanceEntity1.setUpdateTime(DateUtil.getDateTime());
        udiRelevanceService.insertUdiRelevance(udiRelevanceEntity1);
    }


}
