package com.glxp.api.admin.thread;

import com.glxp.api.admin.constant.BasicProcessStatus;
import com.glxp.api.admin.entity.basic.BasicUnitMaintainEntity;
import com.glxp.api.admin.entity.basic.CorpImportDetailEntity;
import com.glxp.api.admin.entity.basic.CorpImportLogEntity;
import com.glxp.api.admin.req.basic.FilterUdiIpLogRequest;
import com.glxp.api.admin.service.basic.BasicUnitMaintainService;
import com.glxp.api.admin.service.basic.CorpImportDetailService;
import com.glxp.api.admin.service.basic.CorpImportLogService;
import org.springframework.beans.BeanUtils;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

@Service
public class BasicCorpImportService {

    @Resource
    CorpImportLogService corpImportLogService;
    @Resource
    CorpImportDetailService corpImportDetailService;
    @Resource
    BasicUnitMaintainService basicUnitMaintainService;

    @Async
    public void importCorps(String genKey) {

        CorpImportLogEntity corpImportLogEntity = corpImportLogService.selectByGenKey(genKey);
        if(corpImportLogEntity!=null && corpImportLogEntity.getStatus() == BasicProcessStatus.UDIINFO_IMPORT_UNPROCESS){
            FilterUdiIpLogRequest filterUdiIpLogRequest = new FilterUdiIpLogRequest();
            filterUdiIpLogRequest.setGenKey(genKey);
            List<CorpImportDetailEntity> corpImportDetailEntities
                    = corpImportDetailService.filterCorpImport(filterUdiIpLogRequest);
            if (corpImportDetailEntities != null) {
                for (CorpImportDetailEntity corpImportDetailEntity : corpImportDetailEntities) {
                    BasicUnitMaintainEntity basicUnitMaintainEntity = new BasicUnitMaintainEntity();
                    BeanUtils.copyProperties(corpImportDetailEntity, basicUnitMaintainEntity);
                    basicUnitMaintainService.insertBasicUnitMaintain(basicUnitMaintainEntity);
                    corpImportDetailEntity.setImportStatus(BasicProcessStatus.UDIINFO_IMPORT_CODE_SUCESS);
                    corpImportDetailService.updateCorpImport(corpImportDetailEntity);
                }
            }
            corpImportLogEntity.setStatus(BasicProcessStatus.UDIINFO_IMPORT_SUCCESS);
            corpImportLogService.updateImportLog(corpImportLogEntity);
        }




    }

}
