package com.glxp.api.admin.thread;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.TypeReference;
import com.glxp.api.admin.constant.ConstantStatus;
import com.glxp.api.admin.entity.basic.BasicThirdSysDetailEntity;
import com.glxp.api.admin.entity.basic.UdiEntity;
import com.glxp.api.admin.entity.basic.UdiInfoEntity;
import com.glxp.api.admin.entity.basic.UdiRelevanceEntity;
import com.glxp.api.admin.entity.info.SystemParamConfigEntity;
import com.glxp.api.admin.entity.thrsys.ThrInvProductsEntity;
import com.glxp.api.admin.entity.thrsys.ThrProductsEntity;
import com.glxp.api.admin.httpclient.ErpBasicClient;
import com.glxp.api.admin.httpclient.ErpInvClient;
import com.glxp.api.admin.req.basic.CombineRequest;
import com.glxp.api.admin.req.basic.FilterErpGoodsRequest;
import com.glxp.api.admin.req.basic.FilterUdiInfoRequest;
import com.glxp.api.admin.req.inventory.ErpOnhandRequest;
import com.glxp.api.admin.req.thrsys.FilterThrInvProductsRequest;
import com.glxp.api.admin.req.thrsys.FilterThrProductsRequest;
import com.glxp.api.admin.res.PageSimpleResponse;
import com.glxp.api.admin.res.basic.ErpProductsResponse;
import com.glxp.api.admin.res.inventory.ErpInvProductResponse;
import com.glxp.api.admin.service.basic.BasicThirdSysDetailService;
import com.glxp.api.admin.service.basic.UdiInfoService;
import com.glxp.api.admin.service.basic.UdiRelevanceService;
import com.glxp.api.admin.service.info.SystemParamConfigService;
import com.glxp.api.admin.service.thrsys.ThrInvProductsService;
import com.glxp.api.admin.service.thrsys.ThrProductsService;
import com.glxp.api.admin.util.CustomUtil;
import com.glxp.api.admin.util.DateUtil;
import com.glxp.api.admin.util.FilterUdiUtils;
import com.glxp.api.admin.util.HttpClient;
import com.glxp.api.common.res.BaseResponse;
import com.glxp.api.common.util.ResultVOUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class BasicUpdateProductService {

    @Value("${UDI_SERVER_URL}")
    private String udiUrl;

    @Resource
    UdiRelevanceService udiRelevanceService;
    @Resource
    UdiInfoService udiInfoService;
    @Resource
    ThrProductsService thrProductsService;
    @Resource
    ThrInvProductsService thrInvProductsService;
    @Resource
    SystemParamConfigService systemParamConfigService;
    @Resource
    BasicThirdSysDetailService basicThirdSysDetailService;


    public String addProduct(CombineRequest combineRequest, String url) {
        String errMsg = null;
        List<String> inventoryCodes = new ArrayList<>();
        if (combineRequest.getThirdIds() == null)
            inventoryCodes.add(combineRequest.getThirdId());
        else {
            inventoryCodes = combineRequest.getThirdIds();
        }
        if (inventoryCodes.size() > 0) {
            for (String inventoryCode : inventoryCodes) {
                UdiRelevanceEntity udiRelevanceEntity1 = new UdiRelevanceEntity();
                udiRelevanceEntity1.setThirdId(inventoryCode);
                FilterErpGoodsRequest filterErpGoodsRequest = new FilterErpGoodsRequest();
                filterErpGoodsRequest.setCode(inventoryCode);
                filterErpGoodsRequest.setPage(1);
                filterErpGoodsRequest.setLimit(1);
                BaseResponse<PageSimpleResponse<ErpProductsResponse>> erpProducts = new ErpBasicClient().getErpProducts(filterErpGoodsRequest, url);
                List<ErpProductsResponse> erpProductsResponses = erpProducts.getData().getList();
                if (erpProductsResponses != null & erpProductsResponses.size() > 0) {
                    if (combineRequest.getIsRlInv() != null && combineRequest.getIsRlInv()) {
                        BasicThirdSysDetailEntity basicThirdSysDetailEntity = basicThirdSysDetailService.selectByKey("piQueryUrl", combineRequest.getThirdSys());
                        if (basicThirdSysDetailEntity.getFromType() == 0) {
                            BasicThirdSysDetailEntity inQuery = basicThirdSysDetailService.selectByKey("invPiUrl", combineRequest.getThirdSys());
                            ErpOnhandRequest erpOnhandRequest = new ErpOnhandRequest();
                            erpOnhandRequest.setInventoryCodes(inventoryCodes);
                            erpOnhandRequest.setFilterCount(2);
                            List<ErpInvProductResponse> erpOnHandResponses = new ErpInvClient().getInvPrdoduct(erpOnhandRequest, inQuery.getValue());
                            if (erpOnHandResponses != null && erpOnHandResponses.size() > 0) {
                                ErpInvProductResponse erpInvProductResponse = erpOnHandResponses.get(0);
                                Map<String, ErpProductsResponse> erpProductsMap = new HashMap<>();
                                erpProductsMap.put(erpInvProductResponse.getCode(), erpProductsResponses.get(0));
                                addRl(erpInvProductResponse, combineRequest.getThirdSys(), erpProductsMap);
                            } else {
                                errMsg = "部分未找到库存信息无法添加！";
                            }
                        } else {
                            FilterThrInvProductsRequest filterThrInvProductsRequest = new FilterThrInvProductsRequest();
                            filterThrInvProductsRequest.setInventoryCode(inventoryCode);
                            filterThrInvProductsRequest.setFilterCount(2);
                            List<ThrInvProductsEntity> thrInvProductsEntities = thrInvProductsService.filterThrInvProductss(filterThrInvProductsRequest);
                            if (thrInvProductsEntities != null && thrInvProductsEntities.size() > 0) {
                                ThrInvProductsEntity thrInvProductsEntity = thrInvProductsEntities.get(0);
                                Map<String, ErpProductsResponse> erpProductsMap = new HashMap<>();
                                ErpInvProductResponse erpProductsResponse = new ErpInvProductResponse();
                                BeanUtils.copyProperties(thrInvProductsEntity, erpProductsResponse);
                                erpProductsResponse.setCode(thrInvProductsEntity.getInventoryCode());
                                erpProductsResponse.setName(thrInvProductsEntity.getInventoryName());
                                erpProductsMap.put(thrInvProductsEntity.getInventoryCode(), erpProductsResponses.get(0));
                                addRl(erpProductsResponse, combineRequest.getThirdSys(), erpProductsMap);
                            } else {
                                errMsg = "部分未找到库存信息无法添加！";
                            }
                        }
                    } else {
                        ErpProductsResponse erpProductsResponse = erpProductsResponses.get(0);
                        UdiInfoEntity udiInfoEntity = new UdiInfoEntity();
                        BeanUtils.copyProperties(erpProductsResponse, udiInfoEntity);
                        udiInfoEntity.setNameCode(erpProductsResponse.getCode());
                        udiInfoEntity.setCpmctymc(erpProductsResponse.getName());
                        udiInfoEntity.setManufactory(erpProductsResponse.getManufactory());
                        udiInfoEntity.setYlqxzcrbarmc(erpProductsResponse.getManufactory());
                        udiInfoEntity.setGgxh(erpProductsResponse.getSpec());
                        udiInfoEntity.setZczbhhzbapzbh(erpProductsResponse.getRegisterNo());
                        udiInfoEntity.setUuid(CustomUtil.getUUId());
                        udiInfoEntity.setProductType(ConstantStatus.PRODUCT_TYPE_THIRD);
                        udiInfoEntity.setDiType(ConstantStatus.DI_TYPE_MAIN);
                        udiInfoService.insertUdiInfo(udiInfoEntity);
                        udiRelevanceEntity1.setUuid(udiInfoEntity.getUuid());
                        udiRelevanceEntity1.setThirdName(erpProductsResponse.getName());
                        udiRelevanceEntity1.setUpdateTime(DateUtil.getDateTime());
                        udiRelevanceService.insertUdiRelevance(udiRelevanceEntity1);
                    }
                }
            }
        }
        return errMsg;
    }

    public String addLocalProduct(CombineRequest combineRequest) {
        String errMsg = null;
        List<String> inventoryCodes = new ArrayList<>();
        if (combineRequest.getThirdIds() == null)
            inventoryCodes.add(combineRequest.getThirdId());
        else {
            inventoryCodes = combineRequest.getThirdIds();
        }
        if (inventoryCodes.size() > 0) {
            for (String inventoryCode : inventoryCodes) {
                UdiRelevanceEntity udiRelevanceEntity1 = new UdiRelevanceEntity();
                udiRelevanceEntity1.setThirdId(inventoryCode);
                FilterThrProductsRequest filterThrProductsRequest = new FilterThrProductsRequest();
                filterThrProductsRequest.setCode(inventoryCode);
                List<ThrProductsEntity> thrProductsEntities = thrProductsService.filterThrProductsRequest(filterThrProductsRequest);
                if (thrProductsEntities != null && thrProductsEntities.size() > 0) {
                    ThrProductsEntity thrProductsEntity = thrProductsEntities.get(0);
                    ErpProductsResponse erpProductsResponse = new ErpProductsResponse();
                    BeanUtils.copyProperties(thrProductsEntity, erpProductsResponse);
                    if (combineRequest.getIsRlInv() != null && combineRequest.getIsRlInv()) {
                        BasicThirdSysDetailEntity basicThirdSysDetailEntity = basicThirdSysDetailService.selectByKey("piQueryUrl", combineRequest.getThirdSys());
                        if (basicThirdSysDetailEntity.getFromType() == 0) {
                            BasicThirdSysDetailEntity inQuery = basicThirdSysDetailService.selectByKey("invPiUrl", combineRequest.getThirdSys());
                            ErpOnhandRequest erpOnhandRequest = new ErpOnhandRequest();
                            erpOnhandRequest.setInventoryCodes(inventoryCodes);
                            erpOnhandRequest.setFilterCount(2);
                            List<ErpInvProductResponse> erpOnHandResponses = new ErpInvClient().getInvPrdoduct(erpOnhandRequest, inQuery.getValue());
                            if (erpOnHandResponses != null && erpOnHandResponses.size() > 0) {
                                ErpInvProductResponse erpInvProductResponse = erpOnHandResponses.get(0);
                                Map<String, ErpProductsResponse> erpProductsMap = new HashMap<>();
                                erpProductsMap.put(erpInvProductResponse.getCode(), erpProductsResponse);
                                addRl(erpInvProductResponse, combineRequest.getThirdSys(), erpProductsMap);
                            } else {
                                errMsg = "部分未找到库存信息无法添加！";
                            }
                        } else {
                            FilterThrInvProductsRequest filterThrInvProductsRequest = new FilterThrInvProductsRequest();
                            filterThrInvProductsRequest.setInventoryCode(inventoryCode);
                            filterThrInvProductsRequest.setFilterCount(2);
                            List<ThrInvProductsEntity> thrInvProductsEntities = thrInvProductsService.filterThrInvProductss(filterThrInvProductsRequest);
                            if (thrInvProductsEntities != null && thrInvProductsEntities.size() > 0) {
                                ThrInvProductsEntity thrInvProductsEntity = thrInvProductsEntities.get(0);
                                Map<String, ErpProductsResponse> erpProductsMap = new HashMap<>();
                                ErpInvProductResponse erpInvProductResponse = new ErpInvProductResponse();
                                BeanUtils.copyProperties(thrInvProductsEntity, erpInvProductResponse);
                                erpInvProductResponse.setCode(thrInvProductsEntity.getInventoryCode());
                                erpInvProductResponse.setName(thrInvProductsEntity.getInventoryName());
                                erpProductsMap.put(thrInvProductsEntity.getInventoryCode(), erpProductsResponse);
                                addRl(erpInvProductResponse, combineRequest.getThirdSys(), erpProductsMap);
                            } else {
                                errMsg = "部分未找到库存信息无法添加！";
                            }
                        }
                    } else {
                        UdiInfoEntity udiInfoEntity = new UdiInfoEntity();
                        BeanUtils.copyProperties(thrProductsEntity, udiInfoEntity);
                        udiInfoEntity.setNameCode(thrProductsEntity.getCode());
                        udiInfoEntity.setCpmctymc(thrProductsEntity.getName());
                        udiInfoEntity.setManufactory(thrProductsEntity.getManufactory());
                        udiInfoEntity.setYlqxzcrbarmc(thrProductsEntity.getManufactory());
                        udiInfoEntity.setGgxh(thrProductsEntity.getSpec());
                        udiInfoEntity.setZczbhhzbapzbh(thrProductsEntity.getRegisterNo());
                        udiInfoEntity.setUuid(CustomUtil.getUUId());
                        udiInfoEntity.setProductType(ConstantStatus.PRODUCT_TYPE_THIRD);
                        udiInfoEntity.setDiType(ConstantStatus.DI_TYPE_MAIN);
                        udiInfoService.insertUdiInfo(udiInfoEntity);
                        udiRelevanceEntity1.setUuid(udiInfoEntity.getUuid());
                        udiRelevanceEntity1.setThirdName(thrProductsEntity.getName());
                        udiRelevanceEntity1.setUpdateTime(DateUtil.getDateTime());
                        udiRelevanceService.insertUdiRelevance(udiRelevanceEntity1);
                    }
                }
            }
        }
        return errMsg;
    }

    public void addRl(ErpInvProductResponse onhandQueryResponse, String
            thirdSysId, Map<String, ErpProductsResponse> erpProductsMap) {
        UdiInfoEntity udiInfoEntity = new UdiInfoEntity();
        udiInfoEntity.setNameCode(onhandQueryResponse.getCode());
        udiInfoEntity.setCpmctymc(onhandQueryResponse.getName());
        udiInfoEntity.setGgxh(onhandQueryResponse.getSpec());
        udiInfoEntity.setUuid(CustomUtil.getUUId());
        udiInfoEntity.setProductType(ConstantStatus.PRODUCT_TYPE_THIRD);
        udiInfoEntity.setDiType(ConstantStatus.DI_TYPE_MAIN);
        udiInfoEntity.setManufactory(erpProductsMap.get(onhandQueryResponse.getCode()).getManufactory());
        udiInfoEntity.setYlqxzcrbarmc(erpProductsMap.get(onhandQueryResponse.getCode()).getManufactory());
        udiInfoEntity.setZczbhhzbapzbh(erpProductsMap.get(onhandQueryResponse.getCode()).getRegisterNo());
        udiInfoService.insertUdiInfo(udiInfoEntity);
        UdiRelevanceEntity udiRelevanceEntity1 = new UdiRelevanceEntity();
        udiRelevanceEntity1.setUuid(udiInfoEntity.getUuid());

        if ("thirdId".equals(thirdSysId)) {
            udiRelevanceEntity1.setThirdId(onhandQueryResponse.getCode());
            udiRelevanceEntity1.setThirdName(onhandQueryResponse.getName());
        } else if ("thirdId1".equals(thirdSysId)) {
            udiRelevanceEntity1.setThirdId1(onhandQueryResponse.getCode());
            udiRelevanceEntity1.setThirdName1(onhandQueryResponse.getName());
        } else if ("thirdId2".equals(thirdSysId)) {
            udiRelevanceEntity1.setThirdId4(onhandQueryResponse.getCode());
            udiRelevanceEntity1.setThirdName4(onhandQueryResponse.getName());
        } else if ("thirdId3".equals(thirdSysId)) {
            udiRelevanceEntity1.setThirdId3(onhandQueryResponse.getCode());
            udiRelevanceEntity1.setThirdName3(onhandQueryResponse.getName());
        } else if ("thirdId4".equals(thirdSysId)) {
            udiRelevanceEntity1.setThirdId4(onhandQueryResponse.getCode());
            udiRelevanceEntity1.setThirdName4(onhandQueryResponse.getName());
        }

        udiRelevanceEntity1.setThirdId(onhandQueryResponse.getCode());
        udiRelevanceEntity1.setThirdName(onhandQueryResponse.getName());
        udiRelevanceEntity1.setUpdateTime(DateUtil.getDateTime());
        udiRelevanceService.insertUdiRelevance(udiRelevanceEntity1);
    }


    //选入查询结果的所有DI
    @Async
    public void relAllUdi(FilterUdiInfoRequest productInfoFilterRequest) {
        int page = 1;
        int limit = 100;
        while (true) {
            productInfoFilterRequest.setPage(page);
            productInfoFilterRequest.setLimit(limit);
            List<UdiInfoEntity> udiInfoEntities = getUdiInfoEntity(productInfoFilterRequest);
            if (udiInfoEntities != null && udiInfoEntities.size() > 0) {
                udiInfoService.insertUdiInfos(udiInfoEntities);
                for (UdiInfoEntity udiInfoEntity : udiInfoEntities) {
                    UdiRelevanceEntity udiRelevanceEntity = new UdiRelevanceEntity();
                    udiRelevanceEntity.setUpdateTime(DateUtil.getDateTime());
                    udiRelevanceEntity.setUuid(udiInfoEntity.getUuid());
                    List<UdiRelevanceEntity> udiRelevanceEntities = udiRelevanceService.selectByUuid(udiInfoEntity.getUuid());
                    if (udiRelevanceEntities != null && udiRelevanceEntities.size() > 0) {
                        boolean isAdd = false;
                        for (UdiRelevanceEntity udiRelevanceEntity1 : udiRelevanceEntities) {
                            if (udiRelevanceEntity1.getThirdId() == null &&
                                    udiRelevanceEntity1.getThirdId2() == null && udiRelevanceEntity1.getThirdId1() == null &&
                                    udiRelevanceEntity1.getThirdId3() == null && udiRelevanceEntity1.getThirdId4() == null) {
                                //不能添加
                                isAdd = false;
                                break;
                            } else {
                                isAdd = true;
                            }
                        }
                        if (isAdd)
                            udiRelevanceService.insertUdiRelevance(udiRelevanceEntity);

                    } else {
                        udiRelevanceService.insertUdiRelevance(udiRelevanceEntity);
                    }
                }
                if (udiInfoEntities.size() < limit) {
                    break;
                } else {
                    page++;
                }
            } else {
                break;
            }

        }


    }


    public List<UdiInfoEntity> getUdiInfoEntity(FilterUdiInfoRequest productInfoFilterRequest) {
        String nameCode = null;
        if (productInfoFilterRequest.getNameCode() != null) {
            UdiEntity udiEntity = FilterUdiUtils.getUdi(productInfoFilterRequest.getNameCode());
            if (udiEntity != null) {
                nameCode = udiEntity.getUdi();
            } else {
                nameCode = productInfoFilterRequest.getNameCode();
            }
        }
        Map<String, Object> paramMap = new HashMap<>(16);
        paramMap.put("page", productInfoFilterRequest.getPage());
        paramMap.put("limit", productInfoFilterRequest.getLimit());
        paramMap.put("ylqxzcrbarmc", productInfoFilterRequest.getYlqxzcrbarmc());
        paramMap.put("cpmctymc", productInfoFilterRequest.getCpmctymc());
        paramMap.put("nameCode", nameCode);
        paramMap.put("ggxh", productInfoFilterRequest.getGgxh());
        paramMap.put("zczbhhzbapzbh", productInfoFilterRequest.getZczbhhzbapzbh());
        paramMap.put("uuid", productInfoFilterRequest.getUuid());

        String response = HttpClient.mipsGet(udiUrl + "/udidl/device/filterUdi", paramMap);
        try {

            BaseResponse<PageSimpleResponse<UdiInfoEntity>> udiDlDeviceResponse =
                    JSONObject.parseObject(response, new TypeReference<BaseResponse<PageSimpleResponse<UdiInfoEntity>>>() {

                    });
            if (udiDlDeviceResponse != null) {
                List<UdiInfoEntity> udiInfoEntities = udiDlDeviceResponse.getData().getList();
                return udiInfoEntities;
            }
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
        return null;
    }

}
