package com.glxp.api.admin.thread;

import com.glxp.api.admin.dao.info.ScheduledDao;
import com.glxp.api.admin.entity.info.ScheduledEntity;
import com.glxp.api.admin.entity.info.SystemParamConfigEntity;
import com.glxp.api.admin.req.info.ScheduledRequest;
import com.glxp.api.admin.service.info.SystemParamConfigService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.SchedulingConfigurer;
import org.springframework.scheduling.config.ScheduledTaskRegistrar;
import org.springframework.scheduling.support.CronTrigger;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;

@Component
@EnableScheduling
public class InvUpdateStock2Task implements SchedulingConfigurer {

    final Logger logger = LoggerFactory.getLogger(IoModifyErpTask.class);

    @Resource
    private InvImportStockService importStockService;
    @Resource
    protected ScheduledDao scheduledDao;
    @Resource
    private SystemParamConfigService systemParamConfigService;

    @Override
    public void configureTasks(ScheduledTaskRegistrar scheduledTaskRegistrar) {
        scheduledTaskRegistrar.addTriggerTask(() -> process(),
                triggerContext -> {
                    ScheduledRequest scheduledRequest = new ScheduledRequest();
                    scheduledRequest.setCronName("updateStock2");
                    ScheduledEntity scheduledEntity = scheduledDao.findScheduled(scheduledRequest);
                    String cron = scheduledEntity.getCron();
                    if (cron.isEmpty()) {
                        logger.error("cron is null");
                    }
                    return new CronTrigger(cron).nextExecutionTime(triggerContext);
                });
    }


    private void process() {
        SystemParamConfigEntity systemParamConfigEntity = systemParamConfigService.selectByParamKey("erp_update_stockprint");
        if ("1".equals(systemParamConfigEntity.getParamValue())) {
            logger.info("定时更新下载电子货位卡");
            SystemParamConfigEntity systemParamConfigEntity1 = systemParamConfigService.selectByParamKey("erp_stockprint_get_invpi");
//            importStockService.updateStock(systemParamConfigEntity1.getParamValue());
        }
    }
}

