package com.glxp.api.admin.thread;

import com.glxp.api.admin.constant.BasicProcessStatus;
import com.glxp.api.admin.entity.basic.BussinessTypeEntity;
import com.glxp.api.admin.entity.thrsys.ThrOrderDetailEntity;
import com.glxp.api.admin.entity.thrsys.ThrOrderEntity;
import com.glxp.api.admin.entity.thrsys.ThrOrderImportDetailEntity;
import com.glxp.api.admin.entity.thrsys.ThrOrderImportLogEntity;
import com.glxp.api.admin.req.basic.FilterUdiIpLogRequest;
import com.glxp.api.admin.service.basic.BussinessTypeService;
import com.glxp.api.admin.service.thrsys.ThrOrderDetailService;
import com.glxp.api.admin.service.thrsys.ThrOrderImportDetailService;
import com.glxp.api.admin.service.thrsys.ThrOrderImportLogService;
import com.glxp.api.admin.service.thrsys.ThrOrderService;
import org.springframework.beans.BeanUtils;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@Service
public class ThrOrderImportService {

    @Resource
    ThrOrderImportLogService thrOrderImportLogService;
    @Resource
    ThrOrderImportDetailService thrOrderImportDetailService;
    @Resource
    ThrOrderService thrOrderService;
    @Resource
    ThrOrderDetailService thrOrderDetailService;
    @Resource
    BussinessTypeService bussinessTypeService;

    @Async
    public void importThrOrder(String genKey) {
        ThrOrderImportLogEntity thrOrderImportLogEntity = thrOrderImportLogService.selectByGenKey(genKey);
        if (thrOrderImportLogEntity.getStatus() == BasicProcessStatus.UDIINFO_IMPORT_UNPROCESS) {
            FilterUdiIpLogRequest filterUdiIpLogRequest = new FilterUdiIpLogRequest();
            filterUdiIpLogRequest.setGenKey(genKey);
            List<ThrOrderImportDetailEntity> thrOrderImportDetailEntities = thrOrderImportDetailService.filterOrderImportDetail(filterUdiIpLogRequest);
            if (thrOrderImportDetailEntities != null && thrOrderImportDetailEntities.size() > 0) {
                Map<String, List<ThrOrderImportDetailEntity>> map = thrOrderImportDetailEntities.stream().collect(Collectors.groupingBy(ThrOrderImportDetailEntity::getBillNo));
                for (List<ThrOrderImportDetailEntity> datas : map.values()) {
                    ThrOrderImportDetailEntity thrOrderImportDetailEntity = datas.get(0);
                    ThrOrderEntity thrOrderEntity = new ThrOrderEntity();
                    BeanUtils.copyProperties(thrOrderImportDetailEntity, thrOrderEntity);
                    thrOrderEntity.setUpdateTime(new Date());
                    BussinessTypeEntity bussinessTypeEntity = bussinessTypeService.findBTByName(thrOrderEntity.getBillType());
                    if (bussinessTypeEntity != null) {
                        thrOrderEntity.setBillType(bussinessTypeEntity.getAction());
                    }
                    thrOrderService.insertThrOrder(thrOrderEntity);
                    thrOrderEntity = thrOrderService.findByUnique(thrOrderEntity.getBillNo(), thrOrderEntity.getThirdSysFk());
                    ThrOrderEntity finalThrOrderEntity = thrOrderEntity;
                    List<ThrOrderDetailEntity> postDatas = datas.stream().map(item ->
                    {
                        ThrOrderDetailEntity thrOrderDetailEntity = new ThrOrderDetailEntity();
                        thrOrderDetailEntity.setUpdateTime(new Date());
                        BeanUtils.copyProperties(item, thrOrderDetailEntity);

                        thrOrderDetailEntity.setOrderIdFk(finalThrOrderEntity.getId() + "");
                        return thrOrderDetailEntity;
                    }).collect(Collectors.toList());
                    thrOrderDetailService.insertThrOrderDetails(postDatas);

                }

                thrOrderImportLogEntity.setStatus(BasicProcessStatus.UDIINFO_IMPORT_SUCCESS);
                thrOrderImportLogService.updateImportLog(thrOrderImportLogEntity);

            }
        }

    }
}
