package com.glxp.api.admin.util;

import com.alibaba.fastjson.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.util.LinkedMultiValueMap;
import org.springframework.util.MultiValueMap;
import org.springframework.web.client.RestTemplate;

import java.io.UnsupportedEncodingException;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLEncoder;
import java.util.Iterator;
import java.util.Map;

public class HttpClient {
    private static final Logger logger = LoggerFactory.getLogger(HttpClient.class);

    public static String post(String url, Object object) {
        RestTemplate restTemplate = new RestTemplate();
        String json = JSONObject.toJSON(object).toString();
        logger.info(url + "\n" + json);
        MultiValueMap<String, Object> postParameters = new LinkedMultiValueMap<>();
        postParameters.add("params", json);
        HttpHeaders headers = new HttpHeaders();
        headers.add("Content-Type", "application/x-www-form-urlencoded");
        HttpEntity<MultiValueMap<String, Object>> httpEntity = new HttpEntity<>(postParameters, headers);
        String response = restTemplate.postForObject(UdidConfig.apiUrl + url, httpEntity, String.class);
        System.out.println(response);

        return response;
    }

    public static String postU8(String url, Object object) {
        RestTemplate restTemplate = new RestTemplate();
        String json = JSONObject.toJSON(object).toString();
//        MultiValueMap<String, Object> postParameters = new LinkedMultiValueMap<>();
//        postParameters.add("params", json);
        logger.info(url + "\n" + json);
        HttpHeaders headers = new HttpHeaders();
        headers.add("Content-Type", "application/json");
        headers.add("system", "1");
        headers.add("apicode", "1b723931cca84aee8ced6b607fc7dabb");
        HttpEntity<String> httpEntity = new HttpEntity<>(json, headers);
        String response = restTemplate.postForObject(url, httpEntity, String.class);
        System.out.println(response);
        return response;
    }

    public static String uCloudPost(String url, Object object) {
        RestTemplate restTemplate = new RestTemplate();
        String json = JSONObject.toJSON(object).toString();
        logger.info(url + "\n" + json);
        HttpHeaders headers = new HttpHeaders();
        headers.add("Content-Type", "application/json");
        HttpEntity<String> httpEntity = new HttpEntity<>(json, headers);
        logger.info(httpEntity.toString());
        String response = restTemplate.postForObject(url, httpEntity, String.class);
        System.out.println(response);
        return response;
    }


    public static String mipsGet(String url) {
        RestTemplate restTemplate = new RestTemplate();
        String accessTokenRequestUrl = url;//"http://127.0.0.1:9997/mips/druginfo/list";
        String response = restTemplate.getForObject(accessTokenRequestUrl, String.class);
        return response;
    }

    public static String mipsGet(String url, Map params) {
        StringBuffer stringBuffer = new StringBuffer(url);
        if (params instanceof Map) {
            Iterator iterator = ((Map) params).entrySet().iterator();
            if (iterator.hasNext()) {
                stringBuffer.append("?");
                Object element;
                while (iterator.hasNext()) {
                    element = iterator.next();
                    Map.Entry<String, Object> entry = (Map.Entry) element;
                    //过滤value为null，value为null时进行拼接字符串会变成 "null"字符串
                    if (entry.getValue() != null) {
                        String value = String.valueOf(((Map.Entry) element).getValue());
                        if(value.contains("#")){
                            try {
                                String ps = URLEncoder.encode(value, "UTF-8");
                                ((Map.Entry) element).setValue(ps);
                            } catch (UnsupportedEncodingException e) {
                                e.printStackTrace();
                            }
                        }

                        stringBuffer.append(element).append("&");
                    }
                    url = stringBuffer.substring(0, stringBuffer.length() - 1);

                }
            }
        } else {
            throw new RuntimeException("url请求:" + url + "请求参数有误不是map类型");
        }
        RestTemplate restTemplate = new RestTemplate();
        String accessTokenRequestUrl = null;
        try {
            accessTokenRequestUrl = new URL(url).toString();
        } catch (MalformedURLException e) {
            e.printStackTrace();
        }
        logger.info(accessTokenRequestUrl);
        String response = restTemplate.getForObject(accessTokenRequestUrl, String.class);
        return response;
    }


}
