package com.glxp.api.admin.util;

import cn.hutool.extra.qrcode.QrCodeUtil;
import com.glxp.api.admin.entity.inout.ErpOrderEntity;
import com.glxp.api.admin.entity.inout.StockOrderDetailEntity;
import com.glxp.api.admin.entity.inout.StockOrderEntity;
import com.glxp.api.admin.req.itextpdf.InoutOrderDetailPDFCodeRequest;
import com.glxp.api.admin.req.itextpdf.InoutOrderDetailPDFFileRequest;
import com.glxp.api.admin.req.itextpdf.StockQRCodeTextPDFTemplateRequest;
import com.itextpdf.text.*;
import com.itextpdf.text.pdf.*;
import com.itextpdf.text.pdf.draw.LineSeparator;
import org.apache.commons.lang3.StringUtils;

import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.List;
import java.util.*;

public class ITextPDFUtils {

    private static int eIOSPDFInfoTotalColumn = 20;

    /**
     * 代码生成PDF测试
     */
    public static void exportPDFTest(HttpServletRequest request, HttpServletResponse response) throws Exception {
        //告诉浏览器用什么软件可以打开此文件
        response.setHeader("content-Type", "application/pdf");
        //下载文件的默认名称
//        response.setHeader("Content-Disposition", "attachment;filename=XXX.pdf");//注释后可直接预览，不注释会直接下载
        //设置中文
        BaseFont bfChinese = BaseFont.createFont("STSong-Light", "UniGB-UCS2-H", BaseFont.NOT_EMBEDDED);
        Font fontChinese = new Font(bfChinese, 12, Font.NORMAL);

        Document document = new Document();
        PdfWriter.getInstance(document, response.getOutputStream());
        // 打开文档
        document.open();
        //设置文档标题
        document.addTitle("PDF");
        //设置文档作者
        document.addAuthor("作者");
        document.addCreationDate();
        //设置关键字
        document.addKeywords("iText");
        document.addLanguage("中文");
        //表头
        PdfPTable title = new PdfPTable(2);//表头行数要对应
        title.addCell(new Paragraph("编号", fontChinese));
        title.addCell(new Paragraph("名称", fontChinese));
        document.add(title);

        //插入数据
        PdfPTable table = new PdfPTable(2);
        table.addCell(new Paragraph("1", fontChinese));
        table.addCell(new Paragraph("测试", fontChinese));
        document.add(table);

        document.close();
    }

    /**
     * 模板文件导入导出PDF测试
     */
    public static void exportPDFFromTemplateFileTest(String filePath, HttpServletRequest request, HttpServletResponse response) {
        try {
            // pdf模板所在路径，就是网站制作好后下载的pdf模板路径
            String fileName = "C:/Users/陈进隆/Desktop/pdf_word.pdf";
//            String fileName = filePath;

            //多个PDF页需要多个ByteArrayOutputStream支持数据的封装
            List<ByteArrayOutputStream> bosList = new ArrayList<>();
            List<PdfReader> readerList = new ArrayList();

            // 使用中文字体
            BaseFont baseFont = BaseFont.createFont("STSong-Light", "UniGB-UCS2-H", BaseFont.NOT_EMBEDDED);
            ArrayList<BaseFont> fontList = new ArrayList<BaseFont>();
            fontList.add(baseFont);

            for (int i = 0; i < 1; i++) {
                //以下三个都需新建，否则分页数据相同。
                PdfReader reader = new PdfReader(fileName);
                ByteArrayOutputStream bos = new ByteArrayOutputStream();
                PdfStamper stamper = new PdfStamper(reader, bos);

                //这个form就是pdf里面的表单key就是pdf的键 value 就是往里面要放的值
                AcroFields form = stamper.getAcroFields();//获取模板上的预订的参数
                form.setSubstitutionFonts(fontList);//设置中文字体

                form.setField("orderId", "1233333333332 " + i);
                form.setField("fromCorp", "医院");
                form.setField("fromType", "网页端");
                form.setField("actionName", "送货单");

                //表格 一行数据是一个list
                List<String> list1 = new ArrayList<String>();
                list1.add("1");

                List<String> list2 = new ArrayList<String>();
                list2.add("2");

                List<String> list3 = new ArrayList<String>();
                list3.add("3");

                List<List<String>> listT = new ArrayList<List<String>>();
                listT.add(list1);
                listT.add(list2);
                listT.add(list3);

                Map<String, List<List<String>>> listMap = new HashMap<String, List<List<String>>>();
                listMap.put("number", listT);
                listMap.put("numberList", listT);

                pdfFileAddTableInColumn(listMap, form, stamper, baseFont, 10);

                List<String> list4 = new ArrayList<String>();
                list4.add("2020-01-01");

                List<String> list5 = new ArrayList<String>();
                list5.add("2018-01-012222222");

                List<String> list6 = new ArrayList<String>();
                list6.add("2019-01-01111111111111111111111111111111111111111");

                listT = new ArrayList<List<String>>();
                listT.add(list4);
                listT.add(list5);
                listT.add(list6);

                listMap = new HashMap<String, List<List<String>>>();
                listMap.put("date", listT);

                pdfFileAddTableInColumn(listMap, form, stamper, baseFont, 10);

                List<String> list7 = new ArrayList<String>();
                list7.add("测试 1");

                List<String> list8 = new ArrayList<String>();
                list8.add("测试 244");

                List<String> list9 = new ArrayList<String>();
                list9.add("测试 333333测试测试测试测试测试测试测试测试");

                listT = new ArrayList<List<String>>();
                listT.add(list7);
                listT.add(list8);
                listT.add(list9);

                listMap = new HashMap<String, List<List<String>>>();
                listMap.put("name", listT);

                pdfFileAddTableInColumn(listMap, form, stamper, baseFont, 10);

                List<String> stringList1 = new ArrayList<>();
                List<String> stringList2 = new ArrayList<>();
                List<String> stringList3 = new ArrayList<>();
                for (int u = 0; u < 35; u++) {
                    stringList1.add("测试： " + u);
                    stringList2.add("测试： " + u);
                    stringList3.add("测试： " + u);
                }
                pdfFileAddTableInQRCode("qrcode", 1, stringList1, form, stamper);

                pdfFileAddTableInQRCode("qrcodeList", 35, stringList2, form, stamper);

                pdfFileAddTableInQRCode("qrcodeList2", 135, stringList3, form, stamper);

//                //表格 一行数据是一个list
//                List<String> list1 = new ArrayList<String>();
//                list1.add("序号");
//                list1.add("日期");
//
//                List<String> list2 = new ArrayList<String>();
//                list2.add("100");
//                list2.add("2018-01-01");
//
//                List<String> list3 = new ArrayList<String>();
//                list3.add("120");
//                list3.add("2019-01-01");
//
//                List<List<String>> listT = new ArrayList<List<String>>();
//                listT.add(list1);
//                listT.add(list2);
//                listT.add(list3);
//
//                Map<String, List<List<String>>> listMapO = new HashMap<String, List<List<String>>>();
//                listMapO.put("testLisst", listT);
//
//                Map<String, Object> o = new HashMap<String, Object>();
//                o.put("list", listMapO);
//
//                // 表格类
//                Map<String, List<List<String>>> listMap = (Map<String, List<List<String>>>) o.get("list");
//                for (String key : listMap.keySet()) {
//                    List<List<String>> lists = listMap.get(key);
//                    int pageNo = form.getFieldPositions(key).get(0).page;
//                    PdfContentByte pcb = stamper.getOverContent(pageNo);//获取文本域对应区域。
//                    Rectangle signRect = form.getFieldPositions(key).get(0).position;//文本域位置信息，定义一个矩形的区域。
//                    //表格位置
//                    int column = lists.get(0).size();
//                    int row = lists.size();
//                    PdfPTable table = new PdfPTable(column);
//                    float totalWidth = signRect.getRight() - signRect.getLeft() - 1;
//                    int size = lists.get(0).size();
//                    float width[] = new float[size];
//                    for (int j = 0; j < size; j++) {
//                        if (j == 0) {
//                            width[j] = 60f;
//                        } else {
//                            width[j] = (totalWidth - 60) / (size - 1);
//                        }
//                    }
//                    table.setTotalWidth(width);
//                    table.setLockedWidth(true);//宽度锁定
//                    table.setKeepTogether(true);
//                    //实现单元格跨页显示
//                    table.setSplitLate(false);
//                    table.setSplitRows(true);
//                    Font FontProve = new Font(baseFont, 10, 0);
//                    //表格数据填写
//                    for (int j = 0; j < row; j++) {
//                        List<String> tList = lists.get(j);
//                        for (int k = 0; k < column; k++) {
//                            Paragraph paragraph = new Paragraph(String.valueOf(tList.get(k)), FontProve);
//                            PdfPCell cell = new PdfPCell(paragraph);
//                            cell.setBorderWidth(1);
//                            cell.setVerticalAlignment(Element.ALIGN_CENTER);
//                            cell.setHorizontalAlignment(Element.ALIGN_CENTER);
//                            cell.setLeading(0, (float) 1.4);
//                            table.addCell(cell);
//                        }
//                    }
//
//                    //将table添加到
//                    table.writeSelectedRows(0, -1, signRect.getLeft(), signRect.getTop(), pcb);
//                }

                //true代表生成的PDF文件不可编辑 必须要调用这个，否则文档不会生成的
                stamper.setFormFlattening(true);
                stamper.close();

                reader = new PdfReader(bos.toByteArray());
                bosList.add(bos);
                readerList.add(reader);
            }

            ServletOutputStream outputStream = response.getOutputStream();
            //访问网页可直接预览
            Document doc = new Document();
            PdfCopy copy = new PdfCopy(doc, outputStream);
            doc.open();

            for (int i = 0; i < readerList.size(); i++) {
                PdfReader pdfReader = readerList.get(i);
                doc.newPage();
                copy.addDocument(readerList.get(i));
//                copy.addDocument(new PdfReader(bosList.get(i).toByteArray()));
            }
//            doc.newPage();
//            copy.addDocument(reader);
//            doc.newPage();
//            copy.addDocument(new PdfReader(bos.toByteArray()));
//            doc.newPage();
//            copy.addDocument(new PdfReader(bos.toByteArray()));
            copy.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 模板文件生成配货单二维码PDF 打印码
     */
    public static void exportStockQRCodeTextPDFFromTemplateFile(
            StockQRCodeTextPDFTemplateRequest stockQRCodeTextPDFTemplateRequest,
            HttpServletRequest request, HttpServletResponse response) {
        try {
            // pdf模板所在路径，就是网站制作好后下载的pdf模板路径
            String fileName = stockQRCodeTextPDFTemplateRequest.getPath();

            //多个PDF页需要多个ByteArrayOutputStream支持数据的封装
            List<ByteArrayOutputStream> bosList = new ArrayList<>();
            List<PdfReader> readerList = new ArrayList();

            // 使用中文字体
            BaseFont baseFont = BaseFont.createFont("STSong-Light", "UniGB-UCS2-H", BaseFont.NOT_EMBEDDED);
            ArrayList<BaseFont> fontList = new ArrayList<BaseFont>();
            fontList.add(baseFont);

            int page = stockQRCodeTextPDFTemplateRequest.getRowCount();

            for (int i = 0; i < page; i++) {
                //以下三个都需新建，否则分页数据相同。
                ByteArrayOutputStream bos = new ByteArrayOutputStream();
                PdfReader reader = new PdfReader(fileName);
                PdfStamper stamper = new PdfStamper(reader, bos);

                //这个form就是pdf里面的表单key就是pdf的键 value 就是往里面要放的值
                AcroFields form = stamper.getAcroFields();//获取模板上的预订的参数
                form.setSubstitutionFonts(fontList);//设置中文字体

                form.setField("code", stockQRCodeTextPDFTemplateRequest.getText());

                form.setField("nowDate", new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
                form.setField("textPage", i + 1 + "");
                form.setField("totalPage", page + "");

                List<String> qrcodeOneList = new ArrayList<>();
                qrcodeOneList.add(stockQRCodeTextPDFTemplateRequest.getText());
                pdfFileAddTableInQRCode("qrcode",
                        page, qrcodeOneList, form, stamper);

                //true代表生成的PDF文件不可编辑 必须要调用这个，否则文档不会生成的
                stamper.setFormFlattening(true);
                stamper.close();

                reader = new PdfReader(bos.toByteArray());
                bosList.add(bos);
                readerList.add(reader);
            }

            ServletOutputStream outputStream = response.getOutputStream();
            //访问网页可直接预览
            Document doc = new Document();
            PdfCopy copy = new PdfCopy(doc, outputStream);
            doc.open();
            // 设置文档标题
            doc.addTitle(stockQRCodeTextPDFTemplateRequest.getText());
            for (int i = 0; i < readerList.size(); i++) {
                PdfReader pdfReader = readerList.get(i);
                doc.newPage();
                copy.addDocument(readerList.get(i));
            }
            copy.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 模板文件生成配货单二维码PDF 打印订单
     */
    public static void exportStockOrderPDFFromTemplateFile(
            StockQRCodeTextPDFTemplateRequest stockQRCodeTextPDFTemplateRequest,
            StockOrderEntity stockOrderEntity, List<StockOrderDetailEntity> stockOrderDetailEntityList,
            HttpServletRequest request, HttpServletResponse response) {
        try {
            // pdf模板所在路径，就是网站制作好后下载的pdf模板路径
            String fileName = stockQRCodeTextPDFTemplateRequest.getPath();

            //多个PDF页需要多个ByteArrayOutputStream支持数据的封装
            List<ByteArrayOutputStream> bosList = new ArrayList<>();
            List<PdfReader> readerList = new ArrayList();

            // 使用中文字体
            BaseFont baseFont = BaseFont.createFont("STSong-Light", "UniGB-UCS2-H", BaseFont.NOT_EMBEDDED);
            ArrayList<BaseFont> fontList = new ArrayList<BaseFont>();
            fontList.add(baseFont);

            int rowCount = stockQRCodeTextPDFTemplateRequest.getRowCount();
            int page = rowCount < stockOrderDetailEntityList.size() ? (int) Math.ceil(stockOrderDetailEntityList.size() / rowCount) : 1;
            int listI = 0;
            int countTotal = 0;
            int reCountTotal = 0;
            for (int i = 0; i < stockOrderDetailEntityList.size(); i++) {
                StockOrderDetailEntity stockOrderDetailEntity = stockOrderDetailEntityList.get(i);
                countTotal = countTotal + Integer.parseInt(stockOrderDetailEntity.getCount());
                reCountTotal = reCountTotal + Integer.parseInt(stockOrderDetailEntity.getReCount());
            }

            for (int i = 0; i < page; i++) {
                //以下三个都需新建，否则分页数据相同。
                ByteArrayOutputStream bos = new ByteArrayOutputStream();
                PdfReader reader = new PdfReader(fileName);
                PdfStamper stamper = new PdfStamper(reader, bos);

                //这个form就是pdf里面的表单key就是pdf的键 value 就是往里面要放的值
                AcroFields form = stamper.getAcroFields();//获取模板上的预订的参数
                form.setSubstitutionFonts(fontList);//设置中文字体

                form.setField("billNo", stockOrderEntity.getBillNo());
                form.setField("billdate", stockOrderEntity.getBilldate());
                form.setField("corpId", stockOrderEntity.getCorpId());
                form.setField("corpName", stockOrderEntity.getCorpName());
                form.setField("actionName", stockQRCodeTextPDFTemplateRequest.getActionName());

                String typeName = "";
                if (StringUtils.isNotBlank(stockOrderEntity.getType())) {
                    switch (stockOrderEntity.getType()) {
                        case "1":
                            typeName = "预入库";
                            break;
                        case "2":
                            typeName = "普通采购";
                            break;
                        default:
                            typeName = "";
                            break;
                    }
                }
                form.setField("type", typeName);

                String sourceTypeName = "";
                if (StringUtils.isNotBlank(stockOrderEntity.getSourceType())) {
                    switch (stockOrderEntity.getSourceType()) {
                        case "1":
                            sourceTypeName = "本地网页新增";
                            break;
                        default:
                            sourceTypeName = "";
                            break;
                    }
                }
                form.setField("sourceType", sourceTypeName);
                form.setField("nowDate", new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
                form.setField("textPage", i + 1 + "");
                form.setField("totalPage", page + "");
                form.setField("countTotal", countTotal + "");
                form.setField("reCountTotal", reCountTotal + "");

//                List<String> qrcodeOneList = new ArrayList<>();
//                qrcodeOneList.add("text");//TODO 待定
//                pdfFileAddTableInQRCode("qrcode",
//                        stockQRCodeTextPDFTemplateRequest.getQrcodeCount(), qrcodeOneList, form, stamper);
//                List<String> stringList1 = new ArrayList<>();
//                for (int u = 0; u < 100; u++) {
//                    stringList1.add("测试： " + u);
//                }
//                pdfFileAddTableInQRCode("qrcodeList",
//                        stockQRCodeTextPDFTemplateRequest.getQrcodeCount(), stringList1, form, stamper);

                List<List<String>> numberList = new ArrayList<List<String>>();
                List<List<String>> productIdList = new ArrayList<List<String>>();
                List<List<String>> productNameList = new ArrayList<List<String>>();
                List<List<String>> specList = new ArrayList<List<String>>();
                List<List<String>> batchNoList = new ArrayList<List<String>>();
                List<List<String>> productDateList = new ArrayList<List<String>>();
                List<List<String>> expireDateList = new ArrayList<List<String>>();
                List<List<String>> countList = new ArrayList<List<String>>();
                List<List<String>> reCountList = new ArrayList<List<String>>();

                int countSubtotal = 0;
                int reCountSubtotal = 0;

                for (int k = 0; k < rowCount && listI < stockOrderDetailEntityList.size(); k++) {
                    ++listI;
                    //序号
                    List<String> list1 = new ArrayList<String>();
                    list1.add(listI + "");
                    numberList.add(list1);

                    StockOrderDetailEntity stockOrderDetailEntity = stockOrderDetailEntityList.get(listI - 1);
                    //产品ID
                    List<String> list2 = new ArrayList<String>();
                    list2.add(stockOrderDetailEntity.getProductId());
                    productIdList.add(list2);
                    //产品名称
                    List<String> list3 = new ArrayList<String>();
                    list3.add(stockOrderDetailEntity.getProductName());
                    productNameList.add(list3);
                    //包装规格
                    List<String> list4 = new ArrayList<String>();
                    list4.add(stockOrderDetailEntity.getSpec());
                    specList.add(list4);
                    //批次号
                    List<String> list5 = new ArrayList<String>();
                    list5.add(stockOrderDetailEntity.getBatchNo() + "");
                    batchNoList.add(list5);
                    //生产日期
                    List<String> list6 = new ArrayList<String>();
                    list6.add(stockOrderDetailEntity.getProductDate() + "");
                    productDateList.add(list6);
                    //失效日期
                    List<String> list7 = new ArrayList<String>();
                    list7.add(stockOrderDetailEntity.getExpireDate() + "");
                    expireDateList.add(list7);
                    //订单数量
                    List<String> list8 = new ArrayList<String>();
                    countSubtotal = countSubtotal + Integer.parseInt(stockOrderDetailEntity.getCount());
                    list8.add(stockOrderDetailEntity.getCount() + "");
                    countList.add(list8);
                    //配货数量
                    List<String> list9 = new ArrayList<String>();
                    reCountSubtotal = reCountSubtotal + Integer.parseInt(stockOrderDetailEntity.getReCount());
                    list9.add(stockOrderDetailEntity.getReCount() + "");
                    reCountList.add(list9);
                }

                form.setField("countSubtotal", countSubtotal + "");
                form.setField("reCountSubtotal", reCountSubtotal + "");

                Map<String, List<List<String>>> listMap = new HashMap<String, List<List<String>>>();
                listMap.put("numberList", numberList);
                listMap.put("productIdList", productIdList);
                listMap.put("productNameList", productNameList);
                listMap.put("specList", specList);
                listMap.put("batchNoList", batchNoList);
                listMap.put("productDateList", productDateList);
                listMap.put("expireDateList", expireDateList);
                listMap.put("countList", countList);
                listMap.put("reCountList", reCountList);

                pdfFileAddTableInColumn(listMap, form, stamper, baseFont, stockQRCodeTextPDFTemplateRequest.getRowCount());

                //true代表生成的PDF文件不可编辑 必须要调用这个，否则文档不会生成的
                stamper.setFormFlattening(true);
                stamper.close();

                reader = new PdfReader(bos.toByteArray());
                bosList.add(bos);
                readerList.add(reader);
            }

            ServletOutputStream outputStream = response.getOutputStream();
            //访问网页可直接预览
            Document doc = new Document();
            PdfCopy copy = new PdfCopy(doc, outputStream);
            doc.open();
            // 设置文档标题
            doc.addTitle(stockQRCodeTextPDFTemplateRequest.getBillNo());
            for (int i = 0; i < readerList.size(); i++) {
                PdfReader pdfReader = readerList.get(i);
                doc.newPage();
                copy.addDocument(readerList.get(i));
            }
            copy.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }



    /**
     * 导入模板文件并导出PDF
     */
    public static void exportOrderDetailPDFFromTemplateFile(
            InoutOrderDetailPDFFileRequest inoutOrderDetailPDFFileRequest, List<ErpOrderEntity> erpOrderEntityList,
            HttpServletRequest request, HttpServletResponse response) {
        try {
            // pdf模板所在路径，就是网站制作好后下载的pdf模板路径
            String fileName = inoutOrderDetailPDFFileRequest.getPath();

            //多个PDF页需要多个ByteArrayOutputStream支持数据的封装
            List<ByteArrayOutputStream> bosList = new ArrayList<>();
            List<PdfReader> readerList = new ArrayList();

            // 使用中文字体
            BaseFont baseFont = BaseFont.createFont("STSong-Light", "UniGB-UCS2-H", BaseFont.NOT_EMBEDDED);
            ArrayList<BaseFont> fontList = new ArrayList<BaseFont>();
            fontList.add(baseFont);

            int rowCount = inoutOrderDetailPDFFileRequest.getRowCount();
            int page = rowCount < erpOrderEntityList.size() ? (int) Math.ceil(erpOrderEntityList.size() / rowCount) : 1;
            int listI = 0;
            int countTotal = 0;
            for (int i = 0; i < erpOrderEntityList.size(); i++) {
                ErpOrderEntity erpOrderEntity = erpOrderEntityList.get(i);
                countTotal = countTotal + erpOrderEntity.getCount();
            }

            for (int i = 0; i < page; i++) {
                //以下三个都需新建，否则分页数据相同。
                ByteArrayOutputStream bos = new ByteArrayOutputStream();
                PdfReader reader = new PdfReader(fileName);
                PdfStamper stamper = new PdfStamper(reader, bos);

                //这个form就是pdf里面的表单key就是pdf的键 value 就是往里面要放的值
                AcroFields form = stamper.getAcroFields();//获取模板上的预订的参数
                form.setSubstitutionFonts(fontList);//设置中文字体

                form.setField("orderId", inoutOrderDetailPDFFileRequest.getOrderId());
                form.setField("fromCorp", inoutOrderDetailPDFFileRequest.getFromCorp());
                form.setField("fromType", inoutOrderDetailPDFFileRequest.getFromType());
                form.setField("actionName", inoutOrderDetailPDFFileRequest.getActionName());
                form.setField("actDate", inoutOrderDetailPDFFileRequest.getActDate());
                form.setField("nowDate", new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
                form.setField("textPage", i + 1 + "");
                form.setField("totalPage", page + "");
                form.setField("countTotal", countTotal + "");

                List<String> stringList1 = new ArrayList<>();
                for (int u = 0; u < 100; u++) {
                    stringList1.add("测试： " + u);
                }
                pdfFileAddTableInQRCode("qrcodeList",
                        inoutOrderDetailPDFFileRequest.getQrcodeCount(), stringList1, form, stamper);

                List<List<String>> numberList = new ArrayList<List<String>>();
                List<List<String>> coNameList = new ArrayList<List<String>>();
                List<List<String>> packSpecList = new ArrayList<List<String>>();
                List<List<String>> batchNoList = new ArrayList<List<String>>();
                List<List<String>> countList = new ArrayList<List<String>>();
                List<List<String>> productCompanyList = new ArrayList<List<String>>();
                List<List<String>> authCodeList = new ArrayList<List<String>>();

                int countSubtotal = 0;

                for (int k = 0; k < rowCount && listI < erpOrderEntityList.size(); k++) {
                    ++listI;
                    //序号
                    List<String> list1 = new ArrayList<String>();
                    list1.add(listI + "");
                    numberList.add(list1);

                    ErpOrderEntity erpOrderEntity = erpOrderEntityList.get(listI - 1);
                    //产品通用名
                    List<String> list2 = new ArrayList<String>();
                    list2.add(erpOrderEntity.getCoName());
                    coNameList.add(list2);
                    //包装规格
                    List<String> list3 = new ArrayList<String>();
                    list3.add(erpOrderEntity.getPackSpec());
                    packSpecList.add(list3);
                    //批次号
                    List<String> list4 = new ArrayList<String>();
                    list4.add(erpOrderEntity.getBatchNo());
                    batchNoList.add(list4);
                    //扫码数量
                    List<String> list5 = new ArrayList<String>();
                    countSubtotal = countSubtotal + erpOrderEntity.getCount();
                    list5.add(erpOrderEntity.getCount() + "");
                    countList.add(list5);
                    //生产企业
                    List<String> list6 = new ArrayList<String>();
                    list6.add(erpOrderEntity.getProductCompany() + "");
                    productCompanyList.add(list6);
                    //批准文号
                    List<String> list7 = new ArrayList<String>();
                    list7.add(erpOrderEntity.getAuthCode() + "");
                    authCodeList.add(list7);
                }

                form.setField("countSubtotal", countSubtotal + "");

                Map<String, List<List<String>>> listMap = new HashMap<String, List<List<String>>>();
                listMap.put("numberList", numberList);
                listMap.put("coNameList", coNameList);
                listMap.put("packSpecList", packSpecList);
                listMap.put("batchNoList", batchNoList);
                listMap.put("countList", countList);
                listMap.put("productCompanyList", productCompanyList);
                listMap.put("authCodeList", authCodeList);

                pdfFileAddTableInColumn(listMap, form, stamper, baseFont, inoutOrderDetailPDFFileRequest.getRowCount());

                //true代表生成的PDF文件不可编辑 必须要调用这个，否则文档不会生成的
                stamper.setFormFlattening(true);
                stamper.close();

                reader = new PdfReader(bos.toByteArray());
                bosList.add(bos);
                readerList.add(reader);
            }

            ServletOutputStream outputStream = response.getOutputStream();
            //访问网页可直接预览
            Document doc = new Document();
            PdfCopy copy = new PdfCopy(doc, outputStream);
            doc.open();
            // 设置文档标题
            doc.addTitle(inoutOrderDetailPDFFileRequest.getOrderId());
            for (int i = 0; i < readerList.size(); i++) {
                PdfReader pdfReader = readerList.get(i);
                doc.newPage();
                copy.addDocument(readerList.get(i));
//                copy.addDocument(new PdfReader(bosList.get(i).toByteArray()));
            }
            copy.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 为导入的模板文件相应字段文本域填入表格
     *
     * @param listMap  待生成数据：Map<String, List<List<String>>>
     *                 key为{文本域字段}，value为对应的{文本域List}。
     *                 {文本域List}内{二级List}数量为行数，{二级List}内的字符串数量为列数。
     *
     *                 ---------（文本域字段）-----（文本域List）---------
     *                 -        Map<String, List<List<String>>>     -
     *                 -                     列1      列2      列3   -
     *                 - 行1：List<String>  [String, String, String] -
     *                 - 行2：List<String>  [String, String, String] -
     *                 - 行3：List<String>  [String, String, String] -
     *                 ----------------------------------------------
     *
     * @param form  表单
     * @param stamper   模板
     * @param baseFont   字体
     * @param rowCount   行数
     */
    private static void pdfFileAddTableInColumn(
            Map<String, List<List<String>>> listMap, AcroFields form,
            PdfStamper stamper, BaseFont baseFont, int rowCount) {
        // 表格类
        for (String key : listMap.keySet()) {
            List<List<String>> lists = listMap.get(key);//获取文本域字段对应List
            if (form.getFieldPositions(key) == null) continue;//判断模板是否有设置该字段。
            int pageNo = form.getFieldPositions(key).get(0).page;
            PdfContentByte pcb = stamper.getOverContent(pageNo);//获取文本域对应区域。
            Rectangle signRect = form.getFieldPositions(key).get(0).position;//文本域位置信息，定义一个矩形的区域。
            //表格位置
            int row = lists.size();//行数，为二级List数量，几个List代表几行。
            int column = lists.get(0).size();//列数，为二级List内字符串数量，几个String代表几列。
            PdfPTable table = new PdfPTable(column);//设置每行列数
            float totalWidth = signRect.getRight() - signRect.getLeft() - 1;//获取总宽
            float totalHeight = signRect.getTop() - signRect.getBottom();//获取总高
            int size = lists.get(0).size();//列数
            float[] width = new float[size];

            float signRectHeight = signRect.getHeight();
            float signRectWidth = signRect.getWidth();

            int rowHeight = (int) Math.ceil(signRectHeight / rowCount);//高度 / 行数
            int fontSize = (int) Math.ceil(rowHeight * 0.5);//字体大小 = 行高的50%

            for (int i = 0; i < size; i++) {
                if (size == 1) {
                    width[i] = totalWidth;//单列 宽度等于总宽度
                } else {
                    if (i == 0) {//多列 宽度计算
                        width[i] = 60f;
                    } else {//后面的列宽度平均
                        width[i] = (totalWidth - 60) / (size - 1);
                    }
                }
            }
            try {
                table.setTotalWidth(width);//设置每列宽度
            } catch (DocumentException e) {
                e.printStackTrace();
            }
            table.setLockedWidth(true);//宽度锁定
            table.setKeepTogether(true);
            //实现单元格跨页显示
            table.setSplitLate(false);
            table.setSplitRows(true);
            //表格数据填写
            for (int i = 0; i < row; i++) {
                List<String> tList = lists.get(i);
                for (int k = 0; k < column; k++) {
                    fontSize = 12;
                    if (tList.get(k).length() / 2 * fontSize > signRectWidth) {
                        fontSize = 8;
                    }
//                    if (tList.get(k).length() * fontSize > signRectWidth) {
//
//                        fontSize = (int) Math.ceil(signRectWidth / tList.get(k).length());//宽度 / 字数
//                    }
//                    if (fontSize < 12) fontSize = 12;
//                    else if (fontSize > 48) fontSize = 48;

                    Font FontProve = new Font(baseFont, fontSize, 0);
                    Paragraph paragraph = new Paragraph(String.valueOf(tList.get(k)), FontProve);
                    PdfPCell cell = new PdfPCell(paragraph);
                    setStyle(cell, 1, rowHeight);
                    cell.setBorderWidth(0);//边框宽度
                    table.addCell(cell);
                }
            }

            //将table添加到pdf对应区域
            table.writeSelectedRows(0, -1, signRect.getLeft(), signRect.getTop(), pcb);
        }
    }

    /**
     * 为导入的模板文件相应字段文本域设置二维码
     *
     * @param key   字段名
     * @param qrcodeCount  二维码数量
     * @param contentList  二维码内容 List<String>
     * @param form  表单
     * @param stamper   模板
     */
    private static void pdfFileAddTableInQRCode(
            String key, int qrcodeCount, List<String> contentList,
            AcroFields form, PdfStamper stamper) {
        // 表格类
        if (qrcodeCount < 1 || contentList.size() < 1) return;//判断二维码数量。
        qrcodeCount = Math.min(qrcodeCount, contentList.size());
        if (form.getFieldPositions(key) == null) return;//判断模板是否有设置该字段。
        int pageNo = form.getFieldPositions(key).get(0).page;
        PdfContentByte pcb = stamper.getOverContent(pageNo);//获取文本域对应区域。
        Rectangle signRect = form.getFieldPositions(key).get(0).position;//文本域位置信息，定义一个矩形区域。
        float signRectHeight = signRect.getHeight();
        float signRectWidth = signRect.getWidth();
        float signRectArea = signRectHeight * signRectWidth;//总面积
        float imageArea = signRectArea / qrcodeCount;//二维码面积
        int imageSideLength = (int) Math.floor(Math.sqrt(imageArea));//开方
        if (qrcodeCount == 1) {//如果是单图，使用文本域最小边作为二维码边长。
            imageSideLength = (int) Math.floor(Math.min(signRectWidth, signRectHeight));
        }

        //表格位置
        int column = qrcodeCount <= 1 ? 1 : (int) Math.floor(signRectWidth / imageSideLength);//每行的列数
        int row = 1;
        if (column < qrcodeCount) {//总数大于每行列数，计算行数。
            DecimalFormat df = new DecimalFormat("0.00");
            double d = Double.parseDouble(df.format((double) qrcodeCount / column));
            row = (int) Math.ceil(d);
        }
        PdfPTable table = new PdfPTable(column);//设置每行列数
        float cellWidth = signRectWidth / column;//列宽度，总宽度除以每行列数，如果直接除以图片宽度的话，图片位置会偏左。
        int rowHeight = (int) Math.floor(signRectHeight / row);//行高，总高除以行数。
        int imgSize = (int) Math.floor(Math.min(cellWidth, rowHeight) * 2);//宽和高哪个小选哪个作为二维码的边长。
//        imgSize = 100;
        float[] width = new float[column];
        for (int i = 0; i < column; i++) {
            width[i] = cellWidth;
        }
        try {
            table.setTotalWidth(width);//设置每列宽度
        } catch (DocumentException e) {
            e.printStackTrace();
        }
        table.setLockedWidth(true);//宽度锁定
        table.setKeepTogether(true);//设置段落内容是否在一起，设置为true的话，不会把段落写到下一页
        //实现单元格跨页显示
        table.setSplitLate(false);
        table.setSplitRows(true);

        int nowQRCodeCount = 0;
        //表格数据填写
        for (int j = 0; j < row; j++) {
            for (int k = 0; k < column; k++, nowQRCodeCount++) {
                try {
                    Image image = null;
                    if (nowQRCodeCount < qrcodeCount) {
                        //生成PNG格式的二维码图片，以byte[]形式表示，宽和高都是 xxx 像素
                        byte[] bytes = QrCodeUtil.generatePng(contentList.get(nowQRCodeCount), imgSize, imgSize);
                        image = Image.getInstance(bytes);
                    }//每一行的列都要设置内容，否则该行错位或不显示。
                    PdfPCell cell = new PdfPCell(image, true);
                    setStyle(cell, 1, rowHeight);
                    cell.setBorderWidth(0);//边框宽度//超过总数的内容设置为空图片。
                    table.addCell(cell);
                } catch (BadElementException e) {
                    e.printStackTrace();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }

        //将table添加到pdf对应区域
        table.writeSelectedRows(0, -1, signRect.getLeft(), signRect.getTop(), pcb);
    }

    /**
     * 使用代码的方式根据设置好的模板数据生成PDF
     */
    public static void exportInoutOrderSuccessPDF(
            InoutOrderDetailPDFCodeRequest inoutOrderDetailPDFCodeRequest, List<ErpOrderEntity> erpOrderEntityList,
            HttpServletRequest request, HttpServletResponse response) throws Exception {
        //告诉浏览器用什么软件可以打开此文件
        response.setHeader("content-Type", "application/pdf");

        //设置中文
        BaseFont bfChinese = BaseFont.createFont("STSong-Light", "UniGB-UCS2-H", BaseFont.NOT_EMBEDDED);
        Font fontChineseSize12 = new Font(bfChinese, 12, Font.NORMAL);
        Font fontChineseSize10 = new Font(bfChinese, 10, Font.NORMAL);

        Document document = new Document(PageSize.A4);

        PdfWriter.getInstance(document, response.getOutputStream());
        // 打开文档
        document.open();
        // 设置文档标题
        document.addTitle(inoutOrderDetailPDFCodeRequest.getOrderId());
        // 添加一个内容段落
//        document.add(new Paragraph("P D F 测 试", fontChineseSize12));
        //设置关键字
        document.addKeywords("iText");
        document.addLanguage("中文");

        PdfPTable table = new PdfPTable(eIOSPDFInfoTotalColumn);//总列数
        table.setWidthPercentage(100); // 宽度100%填充
        table.setSpacingBefore(10f); // 前间距
        table.setSpacingAfter(10f); // 后间距

        ITextPDFCellConfig iTextPDFCellConfig = new ITextPDFCellConfig();
        iTextPDFCellConfig.setKeyWidth(4);
        iTextPDFCellConfig.setFont(fontChineseSize12);
        iTextPDFCellConfig.setFixedHeight(20);
        iTextPDFCellConfig.setTotalColumn(eIOSPDFInfoTotalColumn);
        iTextPDFCellConfig.setCellMaxColumn(12);
        iTextPDFCellConfig.setDisableBorderSide(15);
        iTextPDFCellConfig.setHorizontalAlignment(1);

//        iTextPDFCellConfig.setValue("订  单  详  情");
//        PdfPTable titleTable = new PdfPTable(table);
//        setITextPDFSegmentationCell(0, titleTable, iTextPDFCellConfig);
//        document.add(titleTable);

        // 段落
        Paragraph paragraph = new Paragraph("订  单  详  情", fontChineseSize12);
        paragraph.setAlignment(1); //设置文字居中 0靠左   1，居中     2，靠右
        paragraph.setIndentationLeft(12); //设置左缩进
        paragraph.setIndentationRight(12); //设置右缩进
//        paragraph.setFirstLineIndent(24); //设置首行缩进
        paragraph.setLeading(20f); //行间距
//        paragraph.setSpacingBefore(5f); //设置段落上空白
//        paragraph.setSpacingAfter(10f); //设置段落下空白
        document.add(paragraph);

        //直线
        Paragraph p1 = new Paragraph();
        p1.add(new Chunk(new LineSeparator()));
        document.add(p1);

        InoutOrderDetailPDFCodeRequest.SettingData settingData = inoutOrderDetailPDFCodeRequest.getSettingData();

        int useColspan = 0;
        if (settingData.getOrderIdEnable()) {
            iTextPDFCellConfig.setKey("订单ID：");
            iTextPDFCellConfig.setValue(inoutOrderDetailPDFCodeRequest.getOrderId());
            iTextPDFCellConfig.setValueWidth(settingData.getOrderIdWidth());
            useColspan = setITextPDFKeyValueCell(
                    useColspan, table, iTextPDFCellConfig);
        }

        if (settingData.getActionEnable()) {
            iTextPDFCellConfig.setKey("业务类型：");
            iTextPDFCellConfig.setValue(inoutOrderDetailPDFCodeRequest.getActionName());
            iTextPDFCellConfig.setValueWidth(settingData.getActionWidth());
            useColspan = setITextPDFKeyValueCell(
                    useColspan, table, iTextPDFCellConfig);
        }

        if (settingData.getFromCorpEnable()) {
            iTextPDFCellConfig.setKey("往来单位：");
            iTextPDFCellConfig.setValue(inoutOrderDetailPDFCodeRequest.getFromCorp());
            iTextPDFCellConfig.setValueWidth(settingData.getFromCorpWidth());
            useColspan = setITextPDFKeyValueCell(
                    useColspan, table, iTextPDFCellConfig);
        }

        if (settingData.getFromTypeEnable()) {
            iTextPDFCellConfig.setKey("订单来源：");
            iTextPDFCellConfig.setValue(inoutOrderDetailPDFCodeRequest.getFromType());
            iTextPDFCellConfig.setValueWidth(settingData.getFromTypeWidth());
            useColspan = setITextPDFKeyValueCell(
                    useColspan, table, iTextPDFCellConfig);
        }

        iTextPDFCellConfig.setValue("  ");
        useColspan = setITextPDFSegmentationCell(useColspan, table, iTextPDFCellConfig);

        iTextPDFCellConfig.setFont(fontChineseSize10);

        if (settingData.getNumberEnable()) {
            iTextPDFCellConfig.setValueWidth(settingData.getNumberWidth());
            iTextPDFCellConfig.setValue("序号");
            setITextPDFTableCell(table, iTextPDFCellConfig);
        }
        if (settingData.getCoNameEnable()) {
            iTextPDFCellConfig.setValueWidth(settingData.getCoNameWidth());
            iTextPDFCellConfig.setValue("产品通用名");
            setITextPDFTableCell(table, iTextPDFCellConfig);
        }
        if (settingData.getPackSpecEnable()) {
            iTextPDFCellConfig.setValueWidth(settingData.getPackSpecWidth());
            iTextPDFCellConfig.setValue("包装规格");
            setITextPDFTableCell(table, iTextPDFCellConfig);
        }
        if (settingData.getBatchNoEnable()) {
            iTextPDFCellConfig.setValueWidth(settingData.getBatchNoWidth());
            iTextPDFCellConfig.setValue("批次号");
            setITextPDFTableCell(table, iTextPDFCellConfig);
        }
        if (settingData.getCountEnable()) {
            iTextPDFCellConfig.setValueWidth(settingData.getCountWidth());
            iTextPDFCellConfig.setValue("扫码数量");
            setITextPDFTableCell(table, iTextPDFCellConfig);
        }
        if (settingData.getProductCompanyEnable()) {
            iTextPDFCellConfig.setValueWidth(settingData.getProductCompanyWidth());
            iTextPDFCellConfig.setValue("生产企业");
            setITextPDFTableCell(table, iTextPDFCellConfig);
        }
        if (settingData.getAuthCodeEnable()) {
            iTextPDFCellConfig.setValueWidth(settingData.getAuthCodeWidth());
            iTextPDFCellConfig.setValue("批准文号");
            setITextPDFTableCell(table, iTextPDFCellConfig);
        }

        iTextPDFCellConfig.setFixedHeight(40);

        for (int i = 0; i < erpOrderEntityList.size(); i++) {
            ErpOrderEntity erpOrderEntity = erpOrderEntityList.get(i);

            if (settingData.getNumberEnable()) {
                iTextPDFCellConfig.setValueWidth(settingData.getNumberWidth());
                iTextPDFCellConfig.setValue(i + "");
                setITextPDFTableCell(table, iTextPDFCellConfig);
            }
            if (settingData.getCoNameEnable()) {
                iTextPDFCellConfig.setValueWidth(settingData.getCoNameWidth());
                iTextPDFCellConfig.setValue(erpOrderEntity.getCoName());
                setITextPDFTableCell(table, iTextPDFCellConfig);
            }
            if (settingData.getPackSpecEnable()) {
                iTextPDFCellConfig.setValueWidth(settingData.getPackSpecWidth());
                iTextPDFCellConfig.setValue(erpOrderEntity.getPackSpec());
                setITextPDFTableCell(table, iTextPDFCellConfig);
            }
            if (settingData.getBatchNoEnable()) {
                iTextPDFCellConfig.setValueWidth(settingData.getBatchNoWidth());
                iTextPDFCellConfig.setValue(erpOrderEntity.getBatchNo());
                setITextPDFTableCell(table, iTextPDFCellConfig);
            }
            if (settingData.getCountEnable()) {
                iTextPDFCellConfig.setValueWidth(settingData.getCountWidth());
                iTextPDFCellConfig.setValue(erpOrderEntity.getCount() + "");
                setITextPDFTableCell(table, iTextPDFCellConfig);
            }
            if (settingData.getProductCompanyEnable()) {
                iTextPDFCellConfig.setValueWidth(settingData.getProductCompanyWidth());
                iTextPDFCellConfig.setValue(erpOrderEntity.getProductCompany());
                setITextPDFTableCell(table, iTextPDFCellConfig);
            }
            if (settingData.getAuthCodeEnable()) {
                iTextPDFCellConfig.setValueWidth(settingData.getAuthCodeWidth());
                iTextPDFCellConfig.setValue(erpOrderEntity.getAuthCode());
                setITextPDFTableCell(table, iTextPDFCellConfig);
            }
        }

        document.add(table);

        document.close();
    }

    /**
     * 生成表格键值对及剩余宽度填充。
     *
     * @param useColspan         当前行已使用宽度/列数
     * @param table              表格
     * @param iTextPDFCellConfig 单元格配置
     * @return 返回已使用当前行已使用宽度/列数
     */
    private static int setITextPDFKeyValueCell(
            int useColspan, PdfPTable table, ITextPDFCellConfig iTextPDFCellConfig) {

        //判断所需宽度是否超过剩余宽度，超过就填充剩余宽度。
        if (iTextPDFCellConfig.getKeyWidth() + iTextPDFCellConfig.getValueWidth() > iTextPDFCellConfig.getTotalColumn() - useColspan) {
            // 空格 填充
            PdfPCell cellFill = new PdfPCell(new Phrase(" "));
            cellFill.setColspan(iTextPDFCellConfig.getTotalColumn() - useColspan);    // 所占列数
            setStyle(cellFill, iTextPDFCellConfig.getHorizontalAlignment(), iTextPDFCellConfig.getFixedHeight());
            cellFill.disableBorderSide(iTextPDFCellConfig.getDisableBorderSide());
            table.addCell(cellFill);
            useColspan = 0;
        }

        PdfPCell cell1 = new PdfPCell(new Phrase(iTextPDFCellConfig.getKey(), iTextPDFCellConfig.getFont()));
        cell1.setColspan(iTextPDFCellConfig.getKeyWidth());    // 所占列数
        setStyle(cell1, iTextPDFCellConfig.getHorizontalAlignment(), iTextPDFCellConfig.getFixedHeight());
        cell1.disableBorderSide(iTextPDFCellConfig.getDisableBorderSide());
        table.addCell(cell1);

        PdfPCell cell2 = new PdfPCell(new Phrase(iTextPDFCellConfig.getValue(), iTextPDFCellConfig.getFont()));
        cell2.setColspan(iTextPDFCellConfig.getValueWidth());    // 所占列数
        setStyle(cell2, iTextPDFCellConfig.getHorizontalAlignment(), iTextPDFCellConfig.getFixedHeight());
        cell2.disableBorderSide(iTextPDFCellConfig.getDisableBorderSide());
        table.addCell(cell2);

        useColspan = useColspan + iTextPDFCellConfig.getKeyWidth() + iTextPDFCellConfig.getValueWidth();

        //判断使用宽度是否超过单个最大宽度，并小于总宽度，超过就填充剩余宽度。
        if (useColspan > iTextPDFCellConfig.getCellMaxColumn() && useColspan != iTextPDFCellConfig.getTotalColumn()) {
            // 空格 填充
            PdfPCell cellFill = new PdfPCell(new Phrase(" "));
            cellFill.setColspan(iTextPDFCellConfig.getTotalColumn() - useColspan);    // 所占列数
            setStyle(cellFill, iTextPDFCellConfig.getHorizontalAlignment(), iTextPDFCellConfig.getFixedHeight());
            cellFill.disableBorderSide(iTextPDFCellConfig.getDisableBorderSide());
            table.addCell(cellFill);
            useColspan = 0;
        }
        useColspan = useColspan == iTextPDFCellConfig.getTotalColumn() ? 0 : useColspan;

        return useColspan;
    }

    /**
     * 生成表格分割行及剩余宽度填充。
     *
     * @param useColspan         当前行已使用宽度/列数
     * @param table              表格
     * @param iTextPDFCellConfig 单元格配置
     * @return 返回已使用当前行已使用宽度/列数
     */
    private static int setITextPDFSegmentationCell(
            int useColspan, PdfPTable table, ITextPDFCellConfig iTextPDFCellConfig) {

        //判断最后是否还有剩余，有就填充。
        if (useColspan > 0) {
            // 空格 填充
            PdfPCell cellFill = new PdfPCell(new Phrase("  ", iTextPDFCellConfig.getFont()));
            cellFill.setColspan(iTextPDFCellConfig.getTotalColumn() - useColspan);    // 所占列数
            setStyle(cellFill, iTextPDFCellConfig.getHorizontalAlignment(), iTextPDFCellConfig.getFixedHeight());
            cellFill.disableBorderSide(iTextPDFCellConfig.getDisableBorderSide());
            table.addCell(cellFill);
            useColspan = 0;
        }
        // 分割行
        PdfPCell cell = new PdfPCell(new Phrase(iTextPDFCellConfig.getValue(), iTextPDFCellConfig.getFont()));
        cell.setColspan(iTextPDFCellConfig.getTotalColumn());    // 所占列数
        cell.disableBorderSide(iTextPDFCellConfig.getDisableBorderSide());
        setStyle(cell, iTextPDFCellConfig.getHorizontalAlignment(), iTextPDFCellConfig.getFixedHeight());
        table.addCell(cell);

        return useColspan;
    }

    /**
     * 生成表格单元格
     *
     * @param table              表格
     * @param iTextPDFCellConfig 单元格配置
     * @return 返回已使用当前行已使用宽度/列数
     */
    private static void setITextPDFTableCell(PdfPTable table, ITextPDFCellConfig iTextPDFCellConfig) {

        PdfPCell cell = new PdfPCell(new Phrase(iTextPDFCellConfig.getValue(), iTextPDFCellConfig.getFont()));
        cell.setColspan(iTextPDFCellConfig.getValueWidth());    // 所占列数
        setStyle(cell, iTextPDFCellConfig.getHorizontalAlignment(), iTextPDFCellConfig.getFixedHeight());
        table.addCell(cell);
    }

    /**
     * 设置样式
     *
     * @param cell
     */
    private static void setStyle(PdfPCell cell, int horizontalAlignment, int fixedHeight) {
        cell.setFixedHeight(fixedHeight);//行高
        if (horizontalAlignment == 0) {
            cell.setHorizontalAlignment(Element.ALIGN_LEFT);//设置水平靠左
        } else {
            cell.setHorizontalAlignment(Element.ALIGN_CENTER);//设置水平居中
        }
        cell.setVerticalAlignment(Element.ALIGN_MIDDLE);//设置垂直居中
        cell.setBorderWidth(1);//边框宽度
        cell.setLeading(0, (float) 1.0);////设置行间距
    }
}